--To do

--Low prio
-- add current itemlevel (+ item?) to roll window and award window
--add a nuke command to reset savedvariables


--High prio



--Known Bugs
-- 1) options frame may bug out when guild rank name changes (it looks for the old rank name values, might want to switch it to be number based instead) or upon first load. 
--If rank name changed, either modify rank names in wtf to current names or delete lbr files from wtf. If first load, try reloading ui (shoud fix it) or loading defaults
--Options frame only refreshes values upon reload UI - need to find a way around it (problem caused by the fact that if it is hidden, it just shows itself without redrawing)



--CHANGELOG
--0.0.1 - initial version
--0.0.2 - added lbr/LBR as a slash command and debug printing, added OpenLootWindow that gets loot item info
--0.0.2 - added ChatType to determine comm channel and several other general purpose functions (checksum, namedatetime, etc)
--0.0.2 - added LootItemGUID 
--0.0.3 - added first version of saving history for normal rolls
--0.0.4 - added history and options frames, various bugfixes
--0.0.5 - SendLongMessage and ReceiveLongMessage overhaul
--0.0.6 - Resumed working on addon after a one year break 
--0.0.7 - Removed rogue close button from top right of screen, fixed rarity threshold setting not saving properly, added history frame labels, added close button to options
--0.0.8 - Fixed issue with options table not working on first start, fixed button for loading defaults, added button for syncing
--0.0.9 - updated slash commands, added framework for synchronization with ML (functions+UI, now just needs to be enabled)
--0.0.10 - added LBR.PlayerCounters (with /rlr counters slash command), added syncing from Master Looter if his settings are different
--0.0.11 - added Ace3 libs and LDB broker launcher icon



--VERSION 0.0.11
--DATE 05 02 2017



--Initialize variables

if LBRInit==nil then 
	LBRInit=true
	LBRFunctions={}
	LBRSuicideKings ={}
	LBRSuicideKingsIndex={}
	LBRHistory={}
	LBRHistoryIndex={}
end

LBRVar={}
LBRSessionLoot={};

local LBRFunctions=LBRFunctions;

--Create main addon frame for responding to events
local LBRFrame=CreateFrame("Frame","LBRFrame", UIParent)
LBRFrame:Hide()
	
	LBRFrame:RegisterEvent("ADDON_LOADED");
	LBRFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED"); 
	LBRFrame:RegisterEvent("RAID_ROSTER_UPDATE"); 
	LBRFrame:RegisterEvent("CHAT_MSG_ADDON"); 
	LBRFrame:RegisterEvent("CHAT_MSG_WHISPER");
	
	LBRFrame:RegisterEvent("OPEN_MASTER_LOOT_LIST");
	LBRFrame:RegisterEvent("LOOT_OPENED");
	
	LBRFrame:RegisterEvent("LOOT_ITEM_ROLL_WON");
	
	LBRFrame:RegisterEvent("CHAT_MSG_LOOT");
	
	RegisterAddonMessagePrefix("LBR")		--general prefix for the addon
	RegisterAddonMessagePrefix("LBRItem1") 	--sent when an item of threshold value is found in loot window (sent by ML)
	RegisterAddonMessagePrefix("LBRRoll") 	--sent when a player rolls on an item

	RegisterAddonMessagePrefix("LBRRollAnnounce") 	--sent by ML when a player rolls on an item
	RegisterAddonMessagePrefix("LBRReply") 	--sent by ML when a player rolls on an item
	
	RegisterAddonMessagePrefix("LBRAwarded") 	--sent by ML when a player rolls on an item
	
	RegisterAddonMessagePrefix("LBRLongMessage ") 	--used for LongMessage synchronization
	
	RegisterAddonMessagePrefix("LBROptions1") 	--used for requesting options values synchronization
	
	RegisterAddonMessagePrefix("LBROptions2") 	--used for sending options values
	
local function dprint(...)
	if LBRDebug ~= nil then
		print(...)
	end;
end;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- FUNCTIONS--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--AWARDS LOOT TTO HIGHEST ROLLING CANDIDATE WHEN AWARD BUTTON ON ML´S ROLL RECOUNT FRAME IS CLICKED 
function AwardLoot(ButtonName)
	local LootItemGUID,rollframe=strsplit(";",ButtonName)
	local realmDateTime=LBRFunctions.RealmDateTime()
	local li=_G[LootItemGUID.."Table"].index
		
		for ci = 0,GetNumGroupMembers() do
			
			dprint("88-_G[LootItemGUID..Table].HighestSender)=",_G[LootItemGUID.."Table"].HighestSender)
			dprint("89-GetMasterLootCandidate(_G[LootItemGUID..Table].index,ci)=",GetMasterLootCandidate(_G[LootItemGUID.."Table"].index,ci) )
			--dprint ("LBR DEBUG 239 -  printing people eligible for loot:",GetMasterLootCandidate(_G[LootItemGUID.."Table"].index,ci))
			 if (GetMasterLootCandidate(_G[LootItemGUID.."Table"].index,ci) == _G[LootItemGUID.."Table"].HighestSender) then
			 		dprint ("LBR DEBUG 250 - temporarily commented out awarding of loot - function works, but loot is not being given")
					GiveMasterLoot(li, ci);
					LBRFunctions.tRemoveByVal(LBRActiveRolls,LootItemGUID)
					local realmDateTime=LBRFunctions.RealmDateTime()
					_G[LootItemGUID.."Table"].AwardedTo=_G[LootItemGUID.."Table"].HighestSender
					local chatType=LBRFunctions.ChatType()
					dprint("96-chattype=",chatType)
					SendAddonMessage("LBRAwarded",LootItemGUID..";".._G[LootItemGUID.."Table"].AwardedTo..";".._G[LootItemGUID.."Table"].itemlink..";".._G[LootItemGUID.."Table"].index..";".._G[LootItemGUID.."Table"].itemLevel..";".._G[LootItemGUID.."Table"].HighestCurrentItemLink..";".._G[LootItemGUID.."Table"].HighestCurrentItemLevel..";".._G[LootItemGUID.."Table"].HighestRollType..";".._G[LootItemGUID.."Table"].GuildRankName..";".._G[LootItemGUID.."Table"].Randomn,chatType)
					
					-- tinsert (LBRHistory,realmDateTime..";"..LootItemGUID)
				
					
				if _G[LootItemGUID.."Table"].HighestRollType=="BidMS" or _G[LootItemGUID.."Table"].HighestRollType=="BidOS" then
					local name=_G[LootItemGUID.."Table"].HighestSender
					LBRFunctions.SuicideKings(LootItemGUID,_G[LootItemGUID.."Table"].index,"singletarget",_G[LootItemGUID.."Table"].AwardedTo)
					dprint ("LBR DEBUG 217 - suicidist=",name)
					end
				end			
			end
		
	--if LBRHistory[realmDateTime..";"..LootItemGUID]==nil then dprint ("LBR DEBUG 194: No loot was awarded. This might be caused by the Master looter moving from the corpse while rolling - do not do that - if you move too far from corpse or close the blizz loot frame, it breaks the function GetMasterLootCandidate! (if you are sure you didn´t do that, please let Gonerill-Frostmane(EU) know what happened and include as much detail as you can remember. ") end
end


--gives a warning when looting and there is no free bag space (todo:call this when rolling)
function LBRFunctions.FreeSlots()
	local freeslots={}
	
	for id=0,NUM_BAG_SLOTS do
		numfreeslots=GetContainerNumFreeSlots(id)
		tinsert (freeslots,numfreeslots)
	end
	
	local freeslots=LBRFunctions.TableSum(freeslots)
	
	if freeslots==0 then 
		print ("LBR warning - you are rolling for loot with no free bag spaces - make some space in your bag or if you win, the ML won´t be able to give you the item")
	end
end


function LBRFunctions.GetEquippableItemInfo(i, itemLink, lootIcon, lootName, lootQuantity, lootQuality, locked,corpseName)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
	tinsert (LBRSessionLoot,lootName..i)
	local Randomn=fastrandom(1000,9999)
	
	--dprint("debug 144 - ",i,"/",lootName,"/",lootIcon,"/",itemLink,"/",itemLevel,"/",itemEquipLoc,"/",Randomn,"/",corpseName)
	
	local LootMessage=strjoin(";",i,lootName,lootIcon,itemLink,itemLevel,itemEquipLoc,Randomn,corpseName)
	
	local LootItemGUID=LBRFunctions.LootItemGUID(LootMessage)
	local LootMessage=strjoin(";",LootItemGUID,LootMessage)
	--dprint(LootMessage)
	return LootMessage
end

 function LBRFunctions.GetMLName()
 local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
		
		if UnitInParty("Player") == nil then
		LBRName=GetUnitName("Player", true)
		
		elseif lootmethod ~= "master" then
		--dprint ("LBR DEBUG - not using master looter, sending comm to self")
		LBRName=GetUnitName("Player", true)
		
		elseif masterlooterRaidID ~= nil then --I´m in a raid, everything seems to work as intended
		LBRName = GetRaidRosterInfo(masterlooterRaidID)
		--dprint ("LBR DEBUG: GETMLName name= ",LBRName)

		elseif masterlooterRaidID == nil and masterlooterPartyID == 0 and lootmethod == "master" then -- I´m not in a raid and ML is probably myself
		LBRName=GetUnitName("Player", true)
		--dprint ("LBR DEBUG: GETMLName name= ",LBRName)
		
		elseif masterlooterRaidID == nil and masterlooterPartyID ~= 0 and lootmethod == "master" then -- I´m not in a raid, I AM in a party with the masterlooter and ML is probably not myself?
		local temp = strjoin ("","Party",masterlooterPartyID)
		--dprint ("LBR DEBUG 641 - SimpleName arg=",temp)
		--dprint ("LBR DEBUG 642 - UnitName=",(UnitName(temp)))
		LBRName=GetUnitName(temp, true)

	end
	--dprint ("LBRFunctions.GetMLName from RankedLootRoll.lua - LBRName=",LBRName)
	return LBRName
	end

-- gets initial guild rank information and sets default data
function LBRFunctions.GuildRankRollDefaults()

if LBRGuildRanks==nil then
	if IsInGuild()
	   then 
			LBRGuildRanks={}
			wipe (LBRGuildRanks)
			LBRGuildRanks={}
		for i=1,10 do
				local GuildRankName=GuildControlGetRankName(i)
				local GuildRankName=strjoin("-",i,GuildRankName)
				--dprint ("LBR DEBUG 234:GuildRankName=",GuildRankName) -- good for debugging!
				tinsert(LBRGuildRanks,GuildRankName)
				LBRGuildRanks[GuildRankName]={}
				local rollmin=500-(i*50)
				local rollmax=1000-(i*90)
				tinsert(LBRGuildRanks[GuildRankName],rollmin)
				tinsert(LBRGuildRanks[GuildRankName],rollmax)
				LBRFirstRun=true
			end
			LBRGuildRanks["Major"]=400
			LBRGuildRanks["Minor"]=100
			LBRGuildRanks["OffSpec"]=0
			LBRGuildRanks["MajorBid"]=300
			LBRGuildRanks["MinorBid"]=0
			LBRGuildRanks["Pass"]=-10000
			LBRThreshold=4
			LBRGuildRanks["iLvlCoefficient"]=10
			return LBRGuildRanks
			
			else
		--dprint ("LBR DEBUG 258: You cannot set guild rank roll range defaults while you are not in a guild. While this does not bug out, it sets no values either.")
			return LBRGuildRanks
		end
		
	return LBRGuildRanks

	end
	return LBRGuildRanks
end

--PROVIDES INFORMATION ABOUT WHAT ITEMS HAS A PLAYER EQUIPPED IN THE SAME SLOT AS THE ITEM THEY ARE ROLLING FOR	
function LBRFunctions.InspectItemSlot(itemSlot)
	
	--dprint("126-itemSlot=",itemSlot)
	
	if LBRItemSlotsTable==nil then
		LBRItemSlotsTable={}
		LBRItemSlotsTable["INVTYPE_HEAD"]="HeadSlot"
		LBRItemSlotsTable["INVTYPE_NECK"]="NeckSlot"
		LBRItemSlotsTable["INVTYPE_SHOULDER"]="ShoulderSlot"
		LBRItemSlotsTable["INVTYPE_CHEST"]="ChestSlot"
		LBRItemSlotsTable["INVTYPE_ROBE"]="ChestSlot"
		LBRItemSlotsTable["INVTYPE_WAIST"]="WaistSlot"
		LBRItemSlotsTable["INVTYPE_LEGS"]="LegsSlot"
		LBRItemSlotsTable["INVTYPE_FEET"]="FeetSlot"
		LBRItemSlotsTable["INVTYPE_WRIST"]="WristSlot"
		LBRItemSlotsTable["INVTYPE_HAND"]="HandsSlot"
		LBRItemSlotsTable["INVTYPE_FINGER"]="Finger0Slot;Finger1Slot"--
		LBRItemSlotsTable["INVTYPE_TRINKET"]="Trinket0Slot;Trinket1Slot"--
		LBRItemSlotsTable["INVTYPE_CLOAK"]="BackSlot"
		LBRItemSlotsTable["INVTYPE_WEAPON"]="MainHandSlot"
		LBRItemSlotsTable["INVTYPE_SHIELD"]="SecondaryHandSlot"
		LBRItemSlotsTable["INVTYPE_2HWEAPON"]="MainHandSlot"
		LBRItemSlotsTable["INVTYPE_WEAPONMAINHAND"]="MainHandSlot"
		LBRItemSlotsTable["INVTYPE_WEAPONOFFHAND"]="SecondaryHandSlot"
		LBRItemSlotsTable["INVTYPE_HOLDABLE"]="SecondaryHandSlot"
		LBRItemSlotsTable["INVTYPE_RANGED"]="MainHandSlot"
		LBRItemSlotsTable["INVTYPE_THROWN"]="MainHandSlot"
		LBRItemSlotsTable["INVTYPE_RANGEDRIGHT"]="MainHandSlot"
		LBRItemSlotsTable["INVTYPE_RELIC"]="SecondaryHandSlot"
		LBRItemSlotsTable["INVTYPE_BAG"]="Bag"
	end

local itemsFound={}
itemsFound["itemSlot"]=LBRItemSlotsTable[itemSlot]
	
	if itemsFound["itemSlot"]=="Finger0Slot;Finger1Slot" or itemSlot=="Trinket0Slot;Trinket1Slot" then
		itemsFound["itemSlot1"],itemsFound["itemSlot2"]=strsplit(";",itemsFound["itemSlot"])
		dprint("245 - found rings")
		itemsFound["itemSlot"]=nil
	end
		
	if itemsFound["itemSlot"]~=nil and itemsFound["itemSlot"]~="Bag"  then 
		local test=GetInventorySlotInfo(itemsFound["itemSlot"])
		local test=GetInventoryItemID("player",test)
		itemsFound["isEquipped"]=GetInventoryItemID("player",GetInventorySlotInfo(itemsFound["itemSlot"]))
	end

		if itemsFound["isEquipped"]~=nil then
			local slotId=GetInventorySlotInfo(itemsFound["itemSlot"])
			local itemId = GetInventoryItemID("player", slotId)
			local itemLink=GetInventoryItemLink("player", slotId)
			local cItemName, cItemLink, itemRarity, cItemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId,itemLink)
		--dprint("LBR DEBUG 441 - cItemName,cItemLevel,cItemLink=",cItemName,cItemLevel,cItemLink)
			itemsFound["cItemName"]=cItemName
			itemsFound["cItemLevel"]=cItemLevel
			itemsFound["cItemLink"]=cItemLink
		--dprint ("LBR DEBUG 439: itemName, itemLevel, itemLink=",cItemName,", ",cItemLevel,", ",cItemLink)
		end
		
		
	if itemsFound["itemSlot"]==nil then 
	
		if itemsFound["itemSlot1"]~=nil then 
			itemsFound["isEquipped1"]=GetInventoryItemID("player", GetInventorySlotInfo(itemsFound["itemSlot1"]))
			itemsFound["isEquipped2"]=GetInventoryItemID("player", GetInventorySlotInfo(itemsFound["itemSlot2"]))
			dprint ("LBR 276 - isEquipped1,isEquipped2 =",itemsFound["isEquipped1"],"/",itemsFound["isEquipped2"])
		end
		
		
		if itemsFound["isEquipped1"]~=nil then
			--local slotId=GetInventorySlotInfo(itemsFound["isEquipped1"]) -- here is where the error was
			local slotId=GetInventorySlotInfo(itemsFound["itemSlot1"]) -- here I am trying to correct the line
			local itemId = GetInventoryItemID("player", slotId)
			local itemLink=GetInventoryItemLink("player", slotId)
			local cItemName, cItemLink, itemRarity, cItemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId,itemLink)
			itemsFound["cItemName1"]=cItemName
			itemsFound["cItemLevel1"]=cItemLevel
			itemsFound["cItemLink1"]=cItemLink
		end
		
		if itemsFound["isEquipped2"]~=nil then
		--local slotId=GetInventorySlotInfo(itemsFound["isEquipped2"]) -- here is where the error was
			local slotId=GetInventorySlotInfo(itemsFound["itemSlot2"])-- here I am trying to correct the line
			local itemId = GetInventoryItemID("player", slotId)
			local itemLink=GetInventoryItemLink("player", slotId)
			local cItemName, cItemLink, itemRarity, cItemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId,itemLink)
			itemsFound["cItemName2"]=cItemName
			itemsFound["cItemLevel2"]=cItemLevel
			itemsFound["cItemLink2"]=cItemLink
		end
			
			if itemsFound["cItemName1"]==nil then
				itemsFound["cItemLevel1"]=0
			end
			
			if itemsFound["cItemName2"]==nil then
				itemsFound["cItemLevel2"]=0
			end
				
		if tonumber(itemsFound["cItemLevel1"])>=tonumber(itemsFound["cItemLevel2"]) then 
			itemsFound["cItemName"]=itemsFound["cItemName1"]
			itemsFound["cItemLevel"]=itemsFound["cItemLevel1"]
			itemsFound["cItemLink"]=itemsFound["cItemLink1"]
		end
		
		if tonumber(itemsFound["cItemLevel1"])<tonumber(itemsFound["cItemLevel2"]) then 
			itemsFound["cItemName"]=itemsFound["cItemName2"]
			itemsFound["cItemLevel"]=itemsFound["cItemLevel2"]
			itemsFound["cItemLink"]=itemsFound["cItemLink2"]
		end
		
	end
	
	if itemsFound["cItemName"]==nil and itemsFound["cItemName1"]==nil and itemsFound["cItemName2"]==nil	then 
			itemsFound["cItemName"]="none"
			itemsFound["cItemLevel"]=0
			itemsFound["cItemLink"]="-"
	end

	--dprint ("499 - cItemName=",itemsFound["cItemName"]," cItemLevel=",itemsFound["cItemLevel"]," cItemLink=",itemsFound["cItemLink"])
	return itemsFound["cItemName"],itemsFound["cItemLevel"],itemsFound["cItemLink"]
end


--PROVIDES INFORMATION ABOUT HOW MANY TYPES HAS A PERSON ROLLED
function LBRFunctions.NameRollCount(name,rolltype)
	--dprint("287 - NameRollCount, name-rolltype=",name,"-",rolltype)

	if LBRSuicideKings[name]==nil then tinsert(LBRSuicideKingsIndex,name)
		LBRSuicideKings[name]={}
		LBRSuicideKings[name].Major=0
		LBRSuicideKings[name].Minor=0
		LBRSuicideKings[name].OffSpec=0
		LBRSuicideKings[name].Pass=0
		LBRSuicideKings[name].BidMS=0
		LBRSuicideKings[name].BidOS=0
	end
	LBRSuicideKings[name][rolltype]=(LBRSuicideKings[name][rolltype])+1
	--dprint ("LBR DEBUG 179 PlayerCounter for ",name,"/",rolltype," roll=", LBRSuicideKings[""..name][""..rolltype])

end

--gets information about loot items when loot window is opened (todo:create history tables)
function LBRFunctions.OpenLootWindow()

	local chatType=LBRFunctions.ChatType()
	local corpseName=GetUnitName("target",false)
	if corpseName==nil then corpseName="unknown"end
	if LBRActiveRolls==nil then LBRActiveRolls={} end
	
	local i=1;
	
	for i=1, GetNumLootItems() do
		
		if (LootSlotHasItem(i)) then
			local itemLink = GetLootSlotLink(i)
		
			if itemLink~=nil then 
			
				local lootIcon, lootName, lootQuantity, lootQuality, locked = GetLootSlotInfo(i)
				
				if lootQuality>=LBRThreshold and IsEquippableItem(itemLink)==true then --EQUIPPABLE ITEMS OF THRESHOLD QUALITY OR ABOVE 

					local LootMessage=LBRFunctions.GetEquippableItemInfo(i, itemLink, lootIcon, lootName, lootQuantity, lootQuality, locked, corpseName)
					local LootItemGUID=strsplit(";",LootMessage)
					if _G[LootItemGUID.."Table"]==nil then 
						LBRFunctions.RollItemTable(LootItemGUID,lootIcon,lootName,i,itemLink,itemEquipLoc,Randomn,corpseName) 
					end
					
					if 	LBRActiveRolls[LootItemGUID]==nil then 
						LBRActiveRolls[LootItemGUID]={} 
					end
					tinsert(LBRActiveRolls[LootItemGUID],LootMessage)
					SendAddonMessage("LBRItem1",LootMessage,chatType);

				else
							if LBRFunctions.CheckForTier(lootName) ~= nil then 
								dprint ("found", LBRFunctions.CheckForTier(lootName))
							end
							--dprint("found ", itemLink, "(quality ", lootQuality, " - below threshold)")
				end
			
			else
				--dprint ("lootslot ",i, " is not an item (probably a coin)")
			end
		end
	end	
end


-- Most of the scrolling frame for HistoryPanel comes from us.battle.net/wow/en/forum/topic/14058226633 - hopefully in time I´ll understand how it works 

function LBRFunctions.HistoryPanel() -- UI for displaying history of item distribution done by this addon - who got what when from what boss and what were they replacing

table.sort(LBRHistoryIndex, function(a,b) return b<a end)

if LBRHistoryWrapper==nil then do

	-- local data = nil
	-- local data2 = nil
	-- local data3 = nil
	-- local data4 = nil
	-- local data5 = nil
	-- local data6 = nil
	local data = {}
	local data2 = {}
	local data3 = {}
	local data4 = {}
	local data5 = {}
	local data6 = {}
	local data7 = {}
	local scrollFrame -- we'll define this later
	local numButtons = 10 -- number of lines to scrollFrame
	local buttonHeight = 16 -- height of each line

	-- fill data will test data to scroll through

	for k,v in pairs (LBRHistoryIndex) do
		-- structure of history table is: 1-name, 2-old item, 3-new itemname,4-new itemlink,5-new itemlevel, 6-old itemlevel, 7-rolltype, 8-date+time
		
	-- ["20140929144529410"] = {
		-- "Gonerill", -- [1]
		-- "Major", -- [2]
		-- "Veiled Amulet of Life", -- [3]
		-- "|cffa335ee|Hitem:39392:0:0:0:0:0:0:276451072:90:0:0|h[Veiled Amulet of Life]|h|r", -- [4]
		-- "200", -- [5]
		-- "|cffa335ee|Hitem:105465:0:0:0:0:0:0:0:90:0:0|h[Untainted Guardian's Chain]|h|r", -- [6]
		-- "572", -- [7]
		-- "09/29/14 14:46:23", -- [8]
		-- "2-Officer", -- [9]
	-- },

		--local line1,line2,line3,line4,line5,line6,line7,line8=unpack(v)
		
		local line1,line2,line3,line4,line5,line6,line7,line8,line9,line10=unpack(LBRHistory[v])
		local ilvldiff=tonumber(line5)-tonumber(line7)
		if LBRSearchFilter==nil or strfind(strlower(strjoin("",line1,line2,line3,line4,line5,line6,line7,line8,line9,line10)),strlower(LBRSearchFilter))~=nil then
			tinsert (data,line8)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line1)	-- 	second column = name
			tinsert (data3,line4)	-- 	third column = itemlink
			tinsert (data4,strjoin("",line5,"(",ilvldiff,")"))	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line6)	--	fifth colum = old item name
			tinsert (data6,line2)	--	sixth column = rolltype
			tinsert (data7,line10)	--	seventh column = corpsename
		end
	end
	print ("LBR XML DEBUG 916 - history table contains", #data, " lines")


	-- the heart of the scrollframe that updates the buttons
	function update(search)
	if search~=nil then 
			wipe(data)
			wipe(data2)
			wipe(data3)
			wipe(data4)
			wipe(data5)
			wipe(data6)
			wipe(data7)
			
		for k,v in pairs (LBRHistoryIndex) do
			local line1,line2,line3,line4,line5,line6,line7,line8,line9,line10=unpack(LBRHistory[v])
			local ilvldiff=tonumber(line5)-tonumber(line7)
		
			if LBRSearchFilter==nil or strfind(strlower(strjoin("",line1,line2,line3,line4,line5,line6,line7,line8,line9,line10)),strlower(LBRSearchFilter))~=nil then
			tinsert (data,line8)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line1)	-- 	second column = name
			tinsert (data3,line4)	-- 	third column = itemlink
			tinsert (data4,strjoin("",line5,"(",ilvldiff,")"))	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line6)	--	fifth colum = old item name
			tinsert (data6,line2)	--	sixth column = rolltype
			tinsert (data7,line10)	--	seventh column = boss name
			end
		end
	end
		FauxScrollFrame_Update(scrollFrame,#data,numButtons,buttonHeight)
	for index = 1,numButtons do
	local offset = index + FauxScrollFrame_GetOffset(scrollFrame)
	local button = scrollFrame.buttons[index]
	local button2 = scrollFrame.buttons2[index]
	local button3 = scrollFrame.buttons3[index]
	local button4 = scrollFrame.buttons4[index]
	local button5 = scrollFrame.buttons5[index]
	local button6 = scrollFrame.buttons6[index]
	local button7 = scrollFrame.buttons7[index]
	
	button.index = offset
	button2.index = offset
	button3.index = offset
	button4.index = offset
	button5.index = offset
	button6.index = offset
	button7.index = offset
	
	if offset<=#data then
	button:SetText(data[offset])
	button:Show()
	
	button2:SetText(data2[offset])
	button2:Show()

	button3:SetText(data3[offset])
	button3:Show()

	button4:SetText(data4[offset])
	button4:Show()

	button5:SetText(data5[offset])
	button5:Show()
	
	button6:SetText(data6[offset])
	button6:Show()

	button7:SetText(data7[offset])
	button7:Show()

	
	else
	button:Hide()
	button2:Hide()
	button3:Hide()
	button4:Hide()
	button5:Hide()
	button6:Hide()
	button7:Hide()
	end
	end
	end
	
	
	local LBRHistoryWrapper=CreateFrame("Frame","LBRHistoryWrapper",UIParent,"LBRScrollFrameBaseTemplate")
	LBRHistoryWrapper:SetPoint("TOPLEFT",200,-200)
	tinsert(UISpecialFrames,"LBRHistoryWrapper");
	
	
	-- create parent frame
	local frame = CreateFrame("Frame","LBRHistoryFrame",LBRHistoryWrapper)
	frame:SetSize(1040,numButtons*buttonHeight+16)
	frame:SetPoint("CENTER",0,-20)
	frame:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	
	
	--create labels
	local historyLabelDate = LBRHistoryWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
	historyLabelDate:SetPoint("TOPLEFT",25,-40)
	historyLabelDate:SetText("Date/time awarded")
	historyLabelDate:Show()
	
	local historyLabelWinner = LBRHistoryWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
	historyLabelWinner:SetPoint("TOPLEFT",180,-40)
	historyLabelWinner:SetText("Winner")
	historyLabelWinner:Show()
	
	local historyLabelNewItem = LBRHistoryWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
	historyLabelNewItem:SetPoint("TOPLEFT",270,-40)
	historyLabelNewItem:SetText("Awarded item")
	historyLabelNewItem:Show()
	
	local historyLabelILVL = LBRHistoryWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
	historyLabelILVL:SetPoint("TOPLEFT",500,-40)
	historyLabelILVL:SetText("iLvl/upgrade")
	historyLabelILVL:Show()
	
	local historyLabelOldItem = LBRHistoryWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
	historyLabelOldItem:SetPoint("TOPLEFT",585,-40)
	historyLabelOldItem:SetText("Previously equipped item")
	historyLabelOldItem:Show()
	
	local historyLabelRollType = LBRHistoryWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
	historyLabelRollType:SetPoint("TOPLEFT",830,-40)
	historyLabelRollType:SetText("Roll type")
	historyLabelRollType:Show()
	
	local historyLabelDroppedBy = LBRHistoryWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
	historyLabelDroppedBy:SetPoint("TOPLEFT",885,-40)
	historyLabelDroppedBy:SetText("Dropped by")
	historyLabelDroppedBy:Show()
	
	
	-- create the scrollFrame
	scrollFrame = CreateFrame("ScrollFrame","LBRHistoryFrameScrollFrame",frame,"FauxScrollFrameTemplate")
	scrollFrame:SetPoint("TOPLEFT",0,-8)
	scrollFrame:SetPoint("BOTTOMRIGHT",-30,8)
	scrollFrame:SetScript("OnVerticalScroll",function(self,offset)
	FauxScrollFrame_OnVerticalScroll(self, offset, buttonHeight, update)
	end)

	-- add a button to hide the frame
	local historyCloseButton = CreateFrame("Button","LBRHistoryFrameClose",LBRHistoryWrapper,"UIPanelCloseButton")
	historyCloseButton:SetSize(32,32)
	historyCloseButton:SetPoint("TOPRIGHT",-5,-5)


	-- create each line(button) within the scrollFrame
	scrollFrame.buttons = {}
	scrollFrame.buttons2 = {}
	scrollFrame.buttons3 = {}
	scrollFrame.buttons4 = {}
	scrollFrame.buttons5 = {}
	scrollFrame.buttons6 = {}
	scrollFrame.buttons7 = {}
	for i=1,numButtons do
		scrollFrame.buttons[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons2[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons3[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons4[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons5[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons6[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons7[i] = CreateFrame("Button",nil,frame)
		
		local button = scrollFrame.buttons[i]
		button:SetSize(150,buttonHeight)
		button:SetNormalFontObject("GameFontHighlightLeft")
		button:SetPoint("TOPLEFT",8,-(i-1)*buttonHeight-8)
		button:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data[self.index])
			GameTooltip:Show()
		end)
		button:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data[self.index])
		update()
		end)

		
		-- here I´m copying lua for button 1 to button 2
		local button2 = scrollFrame.buttons2[i]
		button2:SetSize(90,buttonHeight)
		button2:SetNormalFontObject("GameFontHighlightLeft")
		button2:SetPoint("TOPLEFT",160,-(i-1)*buttonHeight-8)
		button2:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data2[self.index])
			GameTooltip:Show()
		end)
		button2:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button2:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data2[self.index])
		update()
		end)

		local button3 = scrollFrame.buttons3[i]
		button3:SetSize(250,buttonHeight)
		button3:SetNormalFontObject("GameFontHighlightLeft")
		button3:SetPoint("TOPLEFT",250,-(i-1)*buttonHeight-8) -- ends at 170+200
		button3:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data3[self.index])
			GameTooltip:Show()
		end)
		button3:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button3:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
		SetItemRef(data3[self.index], "-","LeftButton");
		print(data3[self.index])
		update()
		end)

		local button4 = scrollFrame.buttons4[i]
		button4:SetSize(60,buttonHeight)
		button4:SetNormalFontObject("GameFontHighlightLeft")
		button4:SetPoint("TOPLEFT",500,-(i-1)*buttonHeight-8) -- ends at 370+60
		button4:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data4[self.index])
			GameTooltip:Show()
		end)
		button4:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button4:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data4[self.index])
			--tremove(data,self.index)
		update()
		end)

		local button5 = scrollFrame.buttons5[i]
		button5:SetSize(250,buttonHeight)
		button5:SetNormalFontObject("GameFontHighlightLeft")
		button5:SetPoint("TOPLEFT",565,-(i-1)*buttonHeight-8) --ends at 430+200
		button5:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data5[self.index])
			GameTooltip:Show()
		end)
		button5:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button5:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			SetItemRef(data5[self.index], "-","LeftButton");
			print(data5[self.index])
			--tremove(data,self.index)
		update()
		end)

		local button6 = scrollFrame.buttons6[i]
		button6:SetSize(50,buttonHeight)
		button6:SetNormalFontObject("GameFontHighlightLeft")
		button6:SetPoint("TOPLEFT",810,-(i-1)*buttonHeight-8) --ends at 860
		button6:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data6[self.index])
			GameTooltip:Show()
		end)
		button6:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button6:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data6[self.index])
			--tremove(data,self.index)
		update()
		end)

		local button7 = scrollFrame.buttons7[i]
		button7:SetSize(145,buttonHeight)
		button7:SetNormalFontObject("GameFontHighlightLeft")
		button7:SetPoint("TOPLEFT",865,-(i-1)*buttonHeight-8) --ends at 1010
		button7:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data7[self.index])
			GameTooltip:Show()
		end)
		button7:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button7:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data7[self.index])
			--tremove(data,self.index)
		update()
		end)

		end
	
	update() -- always remember to kick off first update, in an OnShow usually
	
	end

	else 
		if LBRHistoryWrapper:IsShown() then 
			print("Hiding LBR history")
			LBRHistoryWrapper:Hide()
		else
			print("Showing LBR history")
			LBRHistoryWrapper:Show()
			update()
		end
	end
end


--used by several functions to determine to which channel to output comm
function LBRFunctions.ChatType()
	if IsInRaid() then return "RAID" end
	if not IsInRaid() and IsInGroup() then  return "PARTY" end
	if not IsInRaid() and not IsInGroup() then  return "GUILD" end 
end


--checks whether there are any tier tokens in the loot
function LBRFunctions.CheckForTier(itemName)
local str1,str2,str3,str4,str5=strsplit(" ",itemName)
	local tiernames=("Vanquisher;Conqueror;Protector;Defender;Champion;Hero")
	if str5~=nil and string.find(tiernames,str5)~= nil then 
		local tierPiece=strjoin(" ","Tier",str1)
		dprint("LBR DEBUG 554 - tier piece detected:", tierPiece)
	return tierPiece
	end
return TierPiece 
end


--checksum calculator
function LBRFunctions.CheckSum(text)
	local counter = 1
	LBRVar.len = string.len(text)
	repeat
		LBRVar.len=ceil(LBRVar.len*0.7)
	until LBRVar.len<190
	for i=1,(LBRVar.len) do
		counter = counter + string.byte(text, i)*math.pow(31, LBRVar.len- i)
	end
	counter = math.fmod(counter, 7919)
	return string.format("%06x", counter)
end


--generates a unique identifier for each piece of loot
function LBRFunctions.LootItemGUID(LootMessage)
	local cs = LBRFunctions.CheckSum(LootMessage) 
	local LootID = LBRFunctions.Strip(LootMessage)
	local LootID = string.sub(LootID, 1, 8)
	local LootItemGUID = strjoin("","LBR",LootID,cs)
	return LootItemGUID
end


--formats number to have desired length by adding preceding zeroes (used for dates etc.)
function LBRFunctions.NumberExactLength(text,length)
do
		if type(text)~="number" then 
		
		return text
		end
		if type(text)=="number" then repeat
				if strlen(text)>length then 
					local text=string.sub(text,1,length)
				elseif strlen(text)<length then 
					local text=strjoin("","0",text)
				return text 
				end
				until strlen(text)==length
			return text 
		end
	return text 
	end
return text 
end

--
function HyperlinkClicked(ButtonName,button)
	do
	local framename,LootItemGUID=strsplit(";",ButtonName)
	if LootItemGUID=="RollFrame" then LootItemGUID,framename=strsplit(";",ButtonName) end
	local link=_G[LootItemGUID.."Table"].itemlink
	local text="text"
	SetItemRef(link, text, button);
   end
end

--SHOWS WHO WAS AWARDED AN ITEM AND SAVES HISTORY
function LBRFunctions.PrintAwarded(arg2)
	local realmDateTime=LBRFunctions.RealmDateTime()
	local LootItemGUID,luckywinner,itemLink,index,itemLevel,HighestCurrentItemLink,HighestCurrentItemLevel,rolltype,guildRankName,randomn=strsplit(";",arg2)
	dprint ("LBR DEBUG 820 -  LootItemGUID=",LootItemGUID,", luckywinner=",luckywinner,", item=",item,", itemLink=",itemLink,", index=",index,", itemLevel=",itemLevel,", rolltype=",rolltype,", HighestCurrentItemLink=",HighestCurrentItemLink,", HighestCurrentItemLevel=",HighestCurrentItemLevel,", guildRankName=",guildRankName,", randomn=",randomn)
	local index=LBRFunctions.NumberExactLength(index,2)
	tinsert(UISpecialFrames,LootItemGUID..";RollFrame")
	if HighestCurrentItemLink==nil then local HighestCurrentItemLink,HighestCurrentItemLevel="?" end
	
	_G[LootItemGUID.."Table"].AwardedTo=luckywinner
		local index=strsub(index,1,1)
	
	LBRHistory[realmDateTime..LootItemGUID]={}

		if LBRHistory[realmDateTime..LootItemGUID] then 
			dprint("831-saving history to ",realmDateTime,LootItemGUID)
			tinsert(LBRHistoryIndex,realmDateTime..LootItemGUID)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],luckywinner)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],rolltype)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],_G[LootItemGUID.."Table"].lootName)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],itemLink)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],itemLevel)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],HighestCurrentItemLink)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],HighestCurrentItemLevel)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],date())
			tinsert(LBRHistory[realmDateTime..LootItemGUID],guildRankName)
			tinsert(LBRHistory[realmDateTime..LootItemGUID],_G[LootItemGUID.."Table"].corpseName)
	
		_G[LootItemGUID..";RollFrame;Winner"]:Show()
		_G[LootItemGUID..";RollFrame;AwardLoot"]:Hide()
	end
end


function LBRFunctions.OptionsPanel() -- LBR Master Looter Options panel
if IsInGuild() == nil then 
	print ("You need to be in a guild to set up guild rank based roll values")

else 
		if LBRGuildRanks==nil then 
			LBRGuildRanks=LBRFunctions.GuildRankRollDefaults() 
		end
	
	if _G[strjoin("-",1,GuildControlGetRankName(1))..";1"]==nil then
	print("LBR DEBUG 337:loading LBR options");
	LBROptionsFrame:Show()
	
	-- button for rolling defaults
		local loadDefaults = CreateFrame("Button", "loadDefaults", LBROptionsFrame, "UIPanelButtonTemplate")
			loadDefaults:SetPoint("TOPLEFT",364,-600)
			loadDefaults:SetSize(120,24)
			loadDefaults:SetText("Load defaults")
			loadDefaults:SetScript("OnClick", function()
						LBRGuildRanks=nil
						LBRFunctions.GuildRankRollDefaults()
						print ("Default LBR values loaded")
						ReloadUI()
						--LBROptionsFrame:Hide()
		end)
	--end of load defaults button
	
	-- button for rolling defaults
		local loadDefaults = CreateFrame("Button", "loadMLValues", LBROptionsFrame, "UIPanelButtonTemplate")
			loadDefaults:SetPoint("TOPLEFT",164,-600)
			loadDefaults:SetSize(160,24)
			loadDefaults:SetText("Load values from ML")
			loadDefaults:SetScript("OnClick", function()
						local method, partyMaster, raidMaster = GetLootMethod()
						if method==("master") then
						LBRGuildRanks=nil
						LBRFunctions.OptionsSyncRequest()
						print ("ML values loaded, please reload your UI if they are not displayed correctly")
						LBROptionsFrame:Hide()
						ReloadUI()
						else
						print("You need to be in Master Looter group to synchronize roll values with your loot master")
						end
						
						end)
	--end of load defaults button
	
	
		local rolltypeEditbox = CreateFrame("EditBox", "Major", LBROptionsFrame,"LBRRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-106);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()
		

		local rolltypeEditbox = CreateFrame("EditBox","Minor", LBROptionsFrame,"LBRRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-136);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("minorfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()
		
		local rolltypeEditbox = CreateFrame("EditBox","OffSpec", LBROptionsFrame,"LBRRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-166);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("offspecfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()

		-- local rolltypeEditbox = CreateFrame("EditBox","MajorBid", LBROptionsFrame,"LBRRollTypeTemplate")
		-- rolltypeEditbox:ClearAllPoints() 
		-- rolltypeEditbox:SetPoint("TOPLEFT",550,-216);
		-- rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		-- rolltypeEditbox:Show()
		
		-- local rolltypefs = rolltypeEditbox:CreateFontString("majorbidfs","OVERLAY", "GameFontNormal")
		-- rolltypefs:SetPoint("TOPLEFT",-80,-10)
		-- rolltypefs:SetText(rolltypefs:GetParent():GetName())
		-- rolltypefs:Show()

		-- local rolltypeEditbox = CreateFrame("EditBox","MinorBid", LBROptionsFrame,"LBRRollTypeTemplate")
		-- rolltypeEditbox:ClearAllPoints() 
		-- rolltypeEditbox:SetPoint("TOPLEFT",550,-246);
		-- rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		-- rolltypeEditbox:Show()
		
		-- local rolltypefs = rolltypeEditbox:CreateFontString("minorbidfs","OVERLAY", "GameFontNormal")
		-- rolltypefs:SetPoint("TOPLEFT",-80,-10)
		-- rolltypefs:SetText(rolltypefs:GetParent():GetName())
		-- rolltypefs:Show()
		
		local rolltypeEditbox = CreateFrame("EditBox","iLvlCoefficient", LBROptionsFrame,"LBRRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",525,-386);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("iLvlCoefficient","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()

	for i=1,10 do
		local yoffset=(-71-(i*35))
		local editBoxName=strjoin("-",i,GuildControlGetRankName(i))
		dprint("LBR DEBUG 928-i= ",i,", guild rank name=",editBoxName)
		local rollmin,rollmax=unpack(LBRGuildRanks[editBoxName])

	
		local editboxmin = CreateFrame("EditBox", editBoxName..";1", LBROptionsFrame,"InputBoxTemplate")
		editboxmin:ClearAllPoints() 
		editboxmin:SetPoint("TOPLEFT",243,yoffset);
		editboxmin:SetSize(40,36) -- Set these to whatever height/width is needed 
		editboxmin:SetText(rollmin)
		editboxmin:SetMaxLetters(5)
		editboxmin:SetAutoFocus(false)
		editboxmin:SetTextInsets(0, 0, 0, 0)
		editboxmin:SetCursorPosition(0)
		editboxmin:SetAttribute("numeric",true)
		
		-- editboxmin:SetScript("OnEnterPressed", function(self)
			-- self:ClearFocus(); -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
			-- local number = self:GetNumber()
			-- dprint ("LBR DEBUG 362 - Setting",self:GetName()," to ",number)
		-- end)
	
		editboxmin:SetScript("OnEnterPressed", function(self)
			self:ClearFocus(); -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(LBRGuildRanks[rankname],position)
			tinsert(LBRGuildRanks[rankname],position,number)
			dprint ("LBR DEBUG 362 - Setting",self:GetName()," to ",number)
		end)
		
		editboxmin:SetScript("OnEditFocusLost", function(self)
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(LBRGuildRanks[rankname],position)
			tinsert(LBRGuildRanks[rankname],position,number)
			dprint ("LBR DEBUG 362 - Setting",self:GetName()," to ",number)
		end)
		
		editboxmin:Show()

		local editboxmax = CreateFrame("EditBox", editBoxName..";2", LBROptionsFrame,"InputBoxTemplate")
		editboxmax:ClearAllPoints() 
		editboxmax:SetPoint("TOPLEFT",346,yoffset);
		editboxmax:SetSize(40,36) -- Set these to whatever height/width is needed 
		editboxmax:SetText(rollmax)
		editboxmax:SetMaxLetters(5)
		editboxmax:SetAutoFocus(false)
		editboxmax:SetTextInsets(0, 0, 0, 0)
		editboxmax:SetCursorPosition(0)
		editboxmax:SetAttribute("numeric",true)
		
		editboxmax:SetScript("OnEnterPressed", function(self)
			self:ClearFocus(); -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(LBRGuildRanks[rankname],position)
			tinsert(LBRGuildRanks[rankname],position,number)
			dprint ("LBR DEBUG 362 - Setting",self:GetName()," to ",number)
		end)

		editboxmax:SetScript("OnEditFocusLost", function(self)
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(LBRGuildRanks[rankname],position)
			tinsert(LBRGuildRanks[rankname],position,number)
			dprint ("LBR DEBUG 362 - Setting",self:GetName()," to ",number)
		end)
		
		editboxmax:Show()		
		
		local ranknamef = CreateFrame("Frame", editBoxName, LBROptionsFrame,GameFontNormal)
		ranknamef:SetPoint("TOPLEFT",75,yoffset-12);
		ranknamef:SetSize(40,36) 
		local rankname = ranknamef:CreateFontString("rankname"..i, LBROptionsFrame, "GameFontNormal")
		rankname:SetPoint("TOPLEFT")
		rankname:SetText(editBoxName)
		rankname:Show()
		end
		
		local slider=CreateFrame("Slider","LBROptionsSlider",LBROptionsFrame)
		slider:SetPoint("TOPLEFT",450,-330)
		slider:SetWidth(132)
		slider:SetHeight(17)
		slider:SetOrientation("HORIZONTAL")
		slider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
		slider:SetMinMaxValues(0,7)
		slider:SetValue(tonumber(LBRThreshold))	
		slider:SetValueStep(1)
		slider:SetObeyStepOnDrag(true)		
		slider:SetBackdrop({
			bgFile = "Interface\\Buttons\\UI-SliderBar-Background",
			edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
			tile = true, tileSize = 8, edgeSize = 8,
			insets = { left = 3, right = 3, top = 6, bottom = 6 }})
 

		slider:SetScript("OnValueChanged", function(self, value)
		if (value~=nil and value>=0 and value<=7) then 
		local value = floor(value)
		LBRThreshold=value
		local r, g, b, hex = GetItemQualityColor(value)
		local text=strjoin("",'|c'..hex, _G["ITEM_QUALITY" .. value .. "_DESC"])--, string.sub(hex,3))
		sliderValue:SetText(text)
		end
		end)
		
		
		
		local sliderValue = slider:CreateFontString("sliderValue", LBROptionsFrame, "GameFontNormal")
		sliderValue:SetPoint("TOPLEFT",60,-20)
		local value=slider:GetValue()
		local value = floor(value)
		local r, g, b, hex = GetItemQualityColor(value)
		local text=strjoin("",'|c'..hex, _G["ITEM_QUALITY" .. value .. "_DESC"])--, string.sub(hex,3))
		sliderValue:SetText(text)
		--sliderValue:SetText(slider:GetValue())
		sliderValue	:Show()
		
		local sliderHeader = slider:CreateFontString("sliderHeader", LBROptionsFrame, "GameFontNormal")
		sliderHeader:SetPoint("TOPLEFT",0,20)
		sliderHeader:SetText("Item rarity to register:")
		sliderHeader:Show()
		
				
		else 
		
			dprint("LBR 1159 - else part of function running")
			if LBROptionsFrame:IsShown() then LBROptionsFrame:Hide() 
			else LBROptionsFrame:Show() 

			dprint("LBR 1163	- else part of function running")

			end
		end
	end
end



function LBRFunctions.OptionsSyncReceive(arg2)
	--print ("received LBR sync message:",arg2, "containing ", strlen(arg2), "characters.")
	
	if	arg2==LBRSettings then 
		dprint("Your Master Looter is using same LBR settings as you are, no sync required.")
	else
		LBRFunctions.OptionsSyncConfirm(arg2)
		dprint("Your Master Looter is using different settings than you are, do you want to load his roll value settings?")
		dprint("(you probably do if this is the first time you are using the addon with your guild.")
	end
	
end

function LBRFunctions.OptionsSyncConfirm(settings)
local mainUIPanel = CreateFrame("frame","mainUIPanelFrame")

	mainUIPanel:SetBackdrop({
		  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
		  edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		  tile=1, tileSize=32, edgeSize=32, 
		  insets={left=11, right=12, top=12, bottom=11}
	})
	mainUIPanel:SetWidth(240)
	mainUIPanel:SetHeight(100)
	mainUIPanel:SetPoint("CENTER",UIParent)
	mainUIPanel:EnableMouse(true)
	mainUIPanel:SetMovable(true)
	mainUIPanel:RegisterForDrag("LeftButton")
	mainUIPanel:SetScript("OnDragStart", function(self) self:StartMoving() end)
	mainUIPanel:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	mainUIPanel:SetFrameStrata("FULLSCREEN_DIALOG")

	local yesbutton = CreateFrame("button","mainUIPanelButton", mainUIPanel, "UIPanelButtonTemplate")
	yesbutton:SetHeight(14)
	yesbutton:SetWidth(60)
	yesbutton:SetPoint("BOTTOM", mainUIPanel, "BOTTOM", -32, 10)
	yesbutton:SetText("Yes")
	yesbutton:SetScript("OnClick", function(self) PlaySound("igMainMenuOption") 
	print("clicked Yes, loading settings")
	
		LBRTemp={strsplit(";",settings)}
		dprint(unpack(LBRTemp))
	
		if LBRGuildRanks~=nil then 	wipe(LBRGuildRanks) end
		
		LBRGuildRanks={}
		
		for i=1,10 do
		local GuildRankName,rollmin,rollmax=strsplit("/",LBRTemp[i+1])
			print("Rank ",GuildRankName," rolls in the range ",rollmin,"-",rollmax)
			tinsert(LBRGuildRanks,GuildRankName)
			LBRGuildRanks[GuildRankName]={}
			--print("1166-still working")
			tinsert(LBRGuildRanks[GuildRankName],rollmin)
			tinsert(LBRGuildRanks[GuildRankName],rollmax)
		end
		 
		local empty,rank1,rank2,rank3,rank4,rank5,rank6,rank7,rank8,rank9,rank10,major,minor,offspec,pass,lbrthhreshold,coefficient=strsplit(";",settings)
		
			LBRGuildRanks["Major"]=LBRTemp[10]
			LBRGuildRanks["Minor"]=LBRTemp[11]
			LBRGuildRanks["OffSpec"]=LBRTemp[12]
			LBRGuildRanks["Pass"]=LBRTemp[13]
			LBRThreshold=LBRTemp[14]
			LBRGuildRanks["iLvlCoefficient"]=LBRTemp[15]
		wipe(LBRTemp)
			
	
	
	self:GetParent():Hide() end)

	local nobutton = CreateFrame("button","mainUIPanelButton", mainUIPanel, "UIPanelButtonTemplate")
	nobutton:SetHeight(14)
	nobutton:SetWidth(60)
	nobutton:SetPoint("BOTTOM", mainUIPanel, "BOTTOM", 32, 10)
	nobutton:SetText("No")
	print("clicked No")
	nobutton:SetScript("OnClick", function(self) PlaySound("igMainMenuOption") self:GetParent():Hide() end)
	
	local confirmationFS = mainUIPanel:CreateFontString("confirmationFS","OVERLAY", "GameFontNormal")
	enabled = confirmationFS:CanWordWrap() 
	confirmationFS:SetPoint("TOPLEFT",20,-20)
	confirmationFS:SetSize(200, 40)
	confirmationFS:SetFont("Fonts\\FRIZQT__.TTF", 9)
	confirmationFS:SetText("You have joined a master looter group, do you want to synchronize your LBR settings with the master looter?")
	confirmationFS:Show()
	
end


function LBRFunctions.OptionsSyncRequest()
	dprint("LBR DEBUG 1117 - requesting options sync")
	
	local method, partyMaster, raidMaster = GetLootMethod()
	if method==("master") then
			SendAddonMessage("LBROptions1","LBRSyncRequest","WHISPER",LBRFunctions.GetMLName())
			dprint("request sent to ",LBRFunctions.GetMLName())
	else 

		print("You need to be in a group using master loot to synchronise settings with the master looter")
	end

end


function LBRFunctions.OptionsSyncSend(requester)
	dprint("LBR 1254 - received sync request, preparing reply to ",requester)
	
	local method=GetLootMethod()
	local LBROptionsSync=""

			for i=1,10 do
				local syncline=strjoin("/",LBRGuildRanks[i],unpack(LBRGuildRanks[LBRGuildRanks[i]]))
				LBROptionsSync=strjoin(";",LBROptionsSync,syncline)
			end

		LBROptionsSync=strjoin(";",LBROptionsSync,LBRGuildRanks["Major"],LBRGuildRanks["Minor"],LBRGuildRanks["OffSpec"],LBRGuildRanks["Pass"],LBRThreshold,LBRGuildRanks["iLvlCoefficient"])
		--dprint("LBR debug 1746 - optionsString is as follows:",LBROptionsSync," and contains ",strlen(LBROptionsSync)," characters.")
		
		LBRSettings=LBROptionsSync
		--print("1248 - saving LBROptionsSync (",LBROptionsSync,")")
				
		if method==("master") then
	
		SendAddonMessage("LBROptions2",LBROptionsSync,"WHISPER",requester) 
		else
		
		print("You need to be in a group using master loot to synchronise settings with the master looter")
	end

return LBRSettings 	
end

function LBRFunctions.PlayerCounters() -- UI for displaying player roll counters - who used which type of roll how many times

table.sort(LBRSuicideKingsIndex, function(a,b) return b<a end)

if LBRPCWrapper==nil then do

	local data = {}
	local data2 = {}
	local data3 = {}
	local data4 = {}
	local data5 = {}
	local data6 = {}
	local data7 = {}
	local scrollFrame -- we'll define this later
	local numButtons = 10 -- number of lines to scrollFrame
	local buttonHeight = 16 -- height of each line

	for k,v in pairs (LBRSuicideKingsIndex)  do

		local line1=(LBRSuicideKingsIndex[k])
		local line2=(LBRSuicideKings[v]["Major"])
		local line3=(LBRSuicideKings[v]["Minor"])
		local line4=(LBRSuicideKings[v]["OffSpec"])
		local line5=(LBRSuicideKings[v]["Pass"])
		local line6=(LBRSuicideKings[v]["BidMS"])
		local line7=(LBRSuicideKings[v]["BidOS"])
		
		if LBRSearchFilter==nil or strfind(strlower(strjoin("",line1,line2,line3,line4,line5,line6,line7)),strlower(LBRSearchFilter))~=nil then
			tinsert (data,line1)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line2)	-- 	second column = name
			tinsert (data3,line3)	-- 	third column = itemlink
			tinsert (data4,line4)	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line5)	--	fifth colum = old item name
			tinsert (data6,line6)	--	sixth column = rolltype
			tinsert (data7,line7)	--	
		end
	
	end
	print ("There are", #data, " roll events recorded in your history.")


	-- the heart of the scrollframe that updates the buttons
	function update(search)
	if search~=nil then 
			wipe(data)
			wipe(data2)
			wipe(data3)
			wipe(data4)
			wipe(data5)
			wipe(data6)
			wipe(data7)
						
		for k,v in pairs (LBRSuicideKingsIndex) do
		
		local line1=(LBRSuicideKingsIndex[k])
		local line2=(LBRSuicideKings[v]["Major"])
		local line3=(LBRSuicideKings[v]["Minor"])
		local line4=(LBRSuicideKings[v]["OffSpec"])
		local line5=(LBRSuicideKings[v]["Pass"])
		local line6=(LBRSuicideKings[v]["BidMS"])
		local line7=(LBRSuicideKings[v]["BidOS"])

		if LBRSearchFilter==nil or strfind(strlower(strjoin("",line1,line2,line3,line4,line5,line6,line7)),strlower(LBRSearchFilter))~=nil then
			tinsert (data,line1)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line2)	-- 	second column = name
			tinsert (data3,line3)	-- 	third column = itemlink
			tinsert (data4,line4)	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line5)	--	fifth colum = old item name
			tinsert (data6,line6)	--	sixth column = rolltype
			tinsert (data7,line7)	--	
		end

		
		end
	end
		FauxScrollFrame_Update(scrollFrame,#data,numButtons,buttonHeight)
	for index = 1,numButtons do
	local offset = index + FauxScrollFrame_GetOffset(scrollFrame)
	local button = scrollFrame.buttons[index]
	local button2 = scrollFrame.buttons2[index]
	local button3 = scrollFrame.buttons3[index]
	local button4 = scrollFrame.buttons4[index]
	local button5 = scrollFrame.buttons5[index]
	local button6 = scrollFrame.buttons6[index]
	local button7 = scrollFrame.buttons7[index]
	
	button.index = offset
	button2.index = offset
	button3.index = offset
	button4.index = offset
	button5.index = offset
	button6.index = offset
	button7.index = offset
	
	if offset<=#data then
	button:SetText(data[offset])
	button:Show()
	
	button2:SetText(data2[offset])
	button2:Show()

	button3:SetText(data3[offset])
	button3:Show()

	button4:SetText(data4[offset])
	button4:Show()

	button5:SetText(data5[offset])
	button5:Show()
	
	button6:SetText(data6[offset])
	button6:Show()

	button7:SetText(data7[offset])
	button7:Show()

	
	else
	button:Hide()
	button2:Hide()
	button3:Hide()
	button4:Hide()
	button5:Hide()
	button6:Hide()
	button7:Hide()
	end
	end
	end
	
	-- create the outlining frame
	local LBRPCWrapper=CreateFrame("Frame","LBRPCWrapper",UIParent,"LBRScrollFrameBaseTemplate")
	LBRPCWrapper:SetSize(580,245)
	LBRPCWrapper:SetPoint("TOPLEFT",200,-200)
	tinsert(UISpecialFrames,"LBRPCWrapper");
	
	local fs = LBRPCWrapper:CreateFontString("namefs","OVERLAY", "GameFontNormal")
		fs:SetPoint("TOPLEFT",20,-40)
		fs:SetText("Name")
		fs:Show()
	
	local fs = LBRPCWrapper:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
		fs:SetPoint("TOPLEFT",170,-40)
		fs:SetText("Major")
		fs:Show()
	
	local fs = LBRPCWrapper:CreateFontString("minorfs","OVERLAY", "GameFontNormal")
		fs:SetPoint("TOPLEFT",230,-40)
		fs:SetText("Minor")
		fs:Show()
	
	local fs = LBRPCWrapper:CreateFontString("offspecfs","OVERLAY", "GameFontNormal")
		fs:SetPoint("TOPLEFT",290,-40)
		fs:SetText("OS")
		fs:Show()
	
	local fs = LBRPCWrapper:CreateFontString("passfs","OVERLAY", "GameFontNormal")
		fs:SetPoint("TOPLEFT",350,-40)
		fs:SetText("Pass")
		fs:Show()
	
	local fs = LBRPCWrapper:CreateFontString("bidmajorfs","OVERLAY", "GameFontNormal")
		fs:SetPoint("TOPLEFT",410,-40)
		fs:SetText("SK MS")
		fs:Show()
		
	local fs = LBRPCWrapper:CreateFontString("bidminorfs","OVERLAY", "GameFontNormal")
		fs:SetPoint("TOPLEFT",470,-40)
		fs:SetText("SK OS")
		fs:Show()
	
	-- create parent frame
	local frame = CreateFrame("Frame","LBRSuicideKingsFrame",LBRPCWrapper)
	frame:SetSize(550,numButtons*buttonHeight+16)
	frame:SetPoint("CENTER",0,-20)
	frame:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	
	
	
	
	-- create the scrollFrame
	scrollFrame = CreateFrame("ScrollFrame","LBRPCScrollFrame",frame,"FauxScrollFrameTemplate")
	scrollFrame:SetPoint("TOPLEFT",0,-8)
	scrollFrame:SetPoint("BOTTOMRIGHT",-30,8)
	scrollFrame:SetScript("OnVerticalScroll",function(self,offset)
	FauxScrollFrame_OnVerticalScroll(self, offset, buttonHeight, update)
	end)

	-- add a button to hide the frame
	local historyCloseButton = CreateFrame("Button","LBRPCFrameClose",LBRPCWrapper,"UIPanelCloseButton")
	historyCloseButton:SetSize(32,32)
	historyCloseButton:SetPoint("TOPRIGHT",-5,-5)


	-- create each line(button) within the scrollFrame
	scrollFrame.buttons = {}
	scrollFrame.buttons2 = {}
	scrollFrame.buttons3 = {}
	scrollFrame.buttons4 = {}
	scrollFrame.buttons5 = {}
	scrollFrame.buttons6 = {}
	scrollFrame.buttons7 = {}
	for i=1,numButtons do
		scrollFrame.buttons[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons2[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons3[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons4[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons5[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons6[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons7[i] = CreateFrame("Button",nil,frame)
		
		local button = scrollFrame.buttons[i]
		button:SetSize(150,buttonHeight)
		button:SetNormalFontObject("GameFontHighlightLeft")
		button:SetPoint("TOPLEFT",10,-(i-1)*buttonHeight-8)
		button:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data[self.index])
			GameTooltip:Show()
		end)
		button:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data[self.index])
		update()
		end)

		
		-- here I´m copying lua for button 1 to button 2
		local button2 = scrollFrame.buttons2[i]
		button2:SetSize(50,buttonHeight)
		button2:SetNormalFontObject("GameFontHighlightLeft")
		button2:SetPoint("TOPLEFT",170,-(i-1)*buttonHeight-8)
		button2:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
		--	GameTooltip:AddLine(data2[self.index])
			GameTooltip:AddLine("Major rolls")
			GameTooltip:Show()
		end)
		button2:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button2:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data2[self.index])
		update()
		end)

local button3 = scrollFrame.buttons3[i]
		button3:SetSize(50,buttonHeight)
		button3:SetNormalFontObject("GameFontHighlightLeft")
		button3:SetPoint("TOPLEFT",230,-(i-1)*buttonHeight-8) -- ends at 170+200
		button3:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine("Minor rolls")
			--GameTooltip:AddLine(data3[self.index])
			GameTooltip:Show()
		end)
		button3:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button3:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
		SetItemRef(data3[self.index], "-","LeftButton");
		print(data3[self.index])
		update()
		end)

local button4 = scrollFrame.buttons4[i]
		button4:SetSize(50,buttonHeight)
		button4:SetNormalFontObject("GameFontHighlightLeft")
		button4:SetPoint("TOPLEFT",290,-(i-1)*buttonHeight-8) -- ends at 370+60
		button4:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			--GameTooltip:AddLine(data4[self.index])
			GameTooltip:AddLine("Offspec rolls")
			GameTooltip:Show()
		end)
		button4:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button4:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data4[self.index])
			--tremove(data,self.index)
		update()
		end)

local button5 = scrollFrame.buttons5[i]
		button5:SetSize(50,buttonHeight)
		button5:SetNormalFontObject("GameFontHighlightLeft")
		button5:SetPoint("TOPLEFT",350,-(i-1)*buttonHeight-8) --ends at 430+200
		button5:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine("Passes")
			--GameTooltip:AddLine(data5[self.index])
			GameTooltip:Show()
		end)
		button5:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button5:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			SetItemRef(data5[self.index], "-","LeftButton");
			print(data5[self.index])
			--tremove(data,self.index)
		update()
		end)

local button6 = scrollFrame.buttons6[i]
		button6:SetSize(50,buttonHeight)
		button6:SetNormalFontObject("GameFontHighlightLeft")
		button6:SetPoint("TOPLEFT",410,-(i-1)*buttonHeight-8) --ends at 430+200
		button6:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine("SK mainspec bids")
			--GameTooltip:AddLine(data5[self.index])
			GameTooltip:Show()
		end)
		button6:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button6:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			SetItemRef(data6[self.index], "-","LeftButton");
			print(data6[self.index])
			--tremove(data,self.index)
		update()
		end)


local button7 = scrollFrame.buttons7[i]
		button7:SetSize(50,buttonHeight)
		button7:SetNormalFontObject("GameFontHighlightLeft")
		button7:SetPoint("TOPLEFT",470,-(i-1)*buttonHeight-8) --ends at 680
		button7:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine("Suicide Kings Offspec bids")
			--GameTooltip:AddLine(data7[self.index])
			GameTooltip:Show()
		end)
		button7:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button7:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data7[self.index])
			--tremove(data,self.index)
		update()
		end)

		end
	
	update() -- always remember to kick off first update, in an OnShow usually
	
	end

else 
		if LBRPCWrapper:IsShown() then 
		print("Hiding LBR  player counters frame")
			LBRPCWrapper:Hide()
	else
	print("Showing LBR player counters frame")
			LBRPCWrapper:Show()
			update()
	end
end
end





--RECEIVES LBRRoll rolling requests, determines in what range the roll will be, performs roll and sends number to everyone
 function LBRFunctions.ProcessRoll(prefix,message,distributiontype,sender)
 
 	local sname, srealm = strsplit("-",sender)

	local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
	local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
	local rolltype,LootItemGUID,cItemName,cItemLevel,cItemLink=strsplit(";",message)
	 
 
 	if _G[LootItemGUID.."Table"].PlayersRolled==nil then -- if table of players who have already rolled doesn´t yet exist, create it
		_G[LootItemGUID.."Table"].PlayersRolled={}
	end

	if tContains(_G[LootItemGUID.."Table"].PlayersRolled,sender)~=nil then 	

		SendChatMessage("LBR DEBUG 471 - You can only roll once on each item","WHISPER",nil,sender)

	else 

		if sguildName==pguildName and pguildName~= nil then do
		
			local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
			local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
			local modifier=LBRFunctions.RollType(rolltype)
			
			local GuildRankName=strjoin("-",sguildRankIndex+1,sguildRankName)
			local rollmin, rollmax = unpack(LBRGuildRanks[GuildRankName])
			local rollmin=rollmin+modifier
			local rollmax=rollmax+modifier
			
			
			local roll=LBRFunctions.RollWithoutTies(LootItemGUID,rollmin,rollmax)
			dprint ("|cFF00FF00",sender, "|r rolls |cFF00FF00",roll, "|r on |cFF0000FF",index,"|r in the range ",rollmin,", ",rollmax)
			local Reply=strjoin(";",roll,LootItemGUID,rollmin,rollmax,rolltype)

			local RaidMessage=strjoin(";",sender,roll,LootItemGUID,rollmin,rollmax,rolltype,cItemName,cItemLevel,cItemLink,GuildRankName)

			SendAddonMessage("LBRRollAnnounce",RaidMessage,LBRFunctions.ChatType()) 
			SendAddonMessage("LBRReply",Reply,"WHISPER",sender) 
			tinsert(_G[LootItemGUID.."Table"].PlayersRolled,sender)
		end
	
		else
			-- SendAddonMessage("LBRReply","You cannot roll if you are not in the guild", "WHISPER",sender) -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNTend
			 -- DEBUG ALLOWING NON GUILDIES TO ROLL - DELETE EVERYTHING FROM HERE ON WHEN DONE
			--dprint("LBR DEBUG 453, sguildName~=pguildName or pguildName==nil - (",pguildName,",",sguildName)
			local rollmin=1
			local rollmax=10
			local roll=math.random(rollmin,rollmax)
			local GuildRankName="unknown"
			local rolltype,LootItemGUID=strsplit(";",message)
			local Reply=strjoin(";",roll,LootItemGUID,rollmin,rollmax,rolltype)
			local RaidMessage=strjoin(";",sender,roll,LootItemGUID,rollmin,rollmax,rolltype,cItemName,cItemLevel,cItemLink,GuildRankName)
			SendAddonMessage("LBRRollAnnounce",RaidMessage,LBRFunctions.ChatType()) 
			SendAddonMessage("LBRReply",Reply,"WHISPER",sender) 
			-- /DEBUG ALLOWING NON GUILDIES TO ROLL
			tinsert(_G[LootItemGUID.."Table"].PlayersRolled,sender)
		end
	end
 end

--gives realm date and time (for timestamping loot history)
function LBRFunctions.RealmDateTime()
	local weekday, month, day, year = CalendarGetDate();
	local hours,minutes = GetGameTime();
	local day=LBRFunctions.NumberExactLength(day,2)
	local month=LBRFunctions.NumberExactLength(month,2)
	local hours=LBRFunctions.NumberExactLength(hours,2)
	local minutes=LBRFunctions.NumberExactLength(minutes,2)
	local realmDateTime=strjoin("/",year, month, day, hours, minutes)
	return realmDateTime
end

function LBRFunctions.ReceiveLBRItem1(message)
	
	--dprint("debug 249-message=",message)
	
	local LootItemGUID,index,lootName,lootIcon,itemlink,itemLevel,itemEquipLoc,Randomn,corpseName=strsplit(";",message)
	
	if _G[LootItemGUID.."Table"]==nil then _G[LootItemGUID.."Table"]={} end -- if this is the first time you see this GUID, make a table for it
	
	--if 	_G[LootItemGUID.."Table"].lootIcon==nil then	-- if you don´t have the table content saved, save it
	--dprint("376-itemEquipLoc=",itemEquipLoc)
		_G[LootItemGUID.."Table"].GUID=LootItemGUID
		_G[LootItemGUID.."Table"].PlayersRolled={}
		_G[LootItemGUID.."Table"].lootIcon=lootIcon
		_G[LootItemGUID.."Table"].lootName=lootName
		_G[LootItemGUID.."Table"].index=index
		_G[LootItemGUID.."Table"].itemlink=itemlink
		_G[LootItemGUID.."Table"].itemLevel=itemLevel
		_G[LootItemGUID.."Table"].itemEquipLoc=itemEquipLoc
		_G[LootItemGUID.."Table"].Randomn=Randomn
		_G[LootItemGUID.."Table"].corpseName=corpseName
	--end

	local framenamejoined=strjoin(";","LBRLoot",LootItemGUID)
		
	if _G[framenamejoined]~=nil then -- if this is an item that you roll for and the roll frame already exists, show it
		_G[framenamejoined]:Show() -- 
		--dprint ("LBR DEBUG 346: already opened rollframe for ",lootName," - don´t create the frame again, just show it!") -- temporary 
		
			if _G[LootItemGUID..";RollFrame"]~=nil then			-- if the roll recount frame should also be shown, show it too!
				_G[LootItemGUID..";RollFrame"]:Show()
			end
		end
		
		if _G[framenamejoined]==nil then --and arg1=="LBRItem1" then	-- if this is an item that you roll for and the roll frame doesn´t exist, create it
			local FrameName = CreateFrame("frame",framenamejoined,UIParent,"RollFrame")
			_G[framenamejoined..";ItemName"]:SetText(itemlink)
			_G[framenamejoined..";IconOfLootItem"]:SetTexture(lootIcon)
			_G[framenamejoined..";Itemlevel"]:SetText(itemLevel)
		end
		
		-- if _G[framenamejoined]==nil and arg1=="LBRSKItem" then
			-- local FrameName = CreateFrame("frame",framenamejoined,UIParent,"SKFrame")
			-- _G[framenamejoined..";ItemName"]:SetText(itemlink)
			-- _G[framenamejoined..";IconOfLootItem"]:SetTexture(lootIcon)
			-- _G[framenamejoined..";Itemlevel"]:SetText(itemLevel)
		-- end
end

-- --INTERPRETS LONG MESSAGES (newer implementation, stores longmessages into tables with GUID and can call functions from them)
function LBRFunctions.ReceiveLongMessage(message)
	
	--dprint("1171-message=",message)
	
	local msgHeader,longMessageGUID,message=strsplit("-",message)

	
	if _G["LBRLongMessage"..longMessageGUID]==nil then _G["LBRLongMessage"..longMessageGUID]={} end

	if msgHeader=="Msta" then
		local messagePartsTemp={strsplit(";",message)}
			
		for i=1,#messagePartsTemp do 
			tinsert(_G["LBRLongMessage"..longMessageGUID],messagePartsTemp[i]);
		end
							
	elseif msgHeader=="Mmid" then
		local messagePartsTemp={strsplit(";",message)}

		for i=1,#messagePartsTemp do
			tinsert(_G["LBRLongMessage"..longMessageGUID],messagePartsTemp[i]);
		end
			
	else 
		local messagePartsTemp={strsplit(";",message)}
		
		for i=1,#messagePartsTemp do
				tinsert(_G["LBRLongMessage"..longMessageGUID],messagePartsTemp[i]);
		end
		
		dprint("ReceiveLongMessage-final table has ",#_G["LBRLongMessage"..longMessageGUID]," elements. Calling ",msgHeader)
		dprint("StringLength total of longmessage is ",strlen(strjoin(";",unpack(_G["LBRLongMessage"..longMessageGUID])))," characters.")
	--implement functioncall callbacks - _G[msgHeader](arg1, arg2, ...)

	end
end

--Receives reply from ML for own rolls
function LBRFunctions.ReceiveReply(Reply)
do
local roll,LootItemGUID,rollmin,rollmax,rolltype=strsplit(";",Reply)
--dprint ("LBR DEBUG 702 - receivereply - roll=",roll,"LootItemGUID=",LootItemGUID,"rollmin=",rollmin,"rollmax=",rollmax,"rolltype=",rolltype)
	if _G[LootItemGUID.."Table"]==nil then
		_G[LootItemGUID.."Table"]={}
	end
	
	if _G[LootItemGUID..";RollFrame"]==nil then
		local RollNumberParentName=strjoin("","LBRLoot;",LootItemGUID)
		--dprint ("LBR DEBUG 297: Parent frame for roll recount frame is ",RollNumberParentName)
		local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[RollNumberParentName],"RollNumberFrame") -- replaced ButtonName by LootItemGUID as second arg on 31/08, still have 3rd arg to go
		RollNumberFrame:SetParent(nil)
		_G[RollNumberFrame.."IconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		_G[RollNumberFrame.."ItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		RollNumberFrame:Show()
		--dprint ("LBR DEBUG 292 - itemlink for roll recount frame =",_G[LootItemGUID.."Table"].itemlink)
		--_G[RollNumberParentName]:GetParent():Hide()
	end
	
	if _G[LootItemGUID..";RollFrame"]~=nil then
	--dprint ("LBR DEBUG 347 - Rollnumber frame already exists, not creating/showing it again")
	end
	
	local ReplyString=strjoin("","You roll |cFF00FF00", roll,"|r on ",_G[LootItemGUID.."Table"].itemlink," in the range ",rollmin,", ",rollmax," (",rolltype," upgrade roll)")
	print("|cFF00FF00",ReplyString)
	_G[LootItemGUID..";RollFrameRoll1"]:SetText(roll)
	_G[LootItemGUID.."Table"].MyRoll=roll
	end
end

-- Receives and processes roll information from ML
function LBRFunctions.RollAnnounce(message)
do
	--dprint ("LBR DEBUG 340 - RollAnnounce message contains ",strlen(message)," characters")
	local sender,roll,LootItemGUID,rollmin,rollmax,rolltype,ItemName,ItemLevel,itemLink,guildRankName=strsplit(";",message)
	local sendername,senderrealm=strsplit("-",sender)
	
	if sendername~=	GetUnitName("Player", false)
 then -- don´t show the print if it´s you 
		print (" |cFFFF0000",sendername,"|r rolls |cFF00FF00", roll,"|r on ",_G[LootItemGUID.."Table"].itemlink," in the range ",rollmin,", ",rollmax," (",rolltype," upgrade roll)")
	end
	
	if _G[LootItemGUID.."Table"]==nil then  -- LootItemGUID table doesn´t yet exist, create it
		_G[LootItemGUID.."Table"]={}
	end
	
	if _G[LootItemGUID..";RollFrame"]==nil then -- if the Roll recount frame doesn´t exist, create it
		local RollNumberParentName=strjoin("","LBRLoot;",LootItemGUID)
		local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[RollNumberParentName],"RollNumberFrame") 
		_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		_G[LootItemGUID..";RollFrame;Itemlevel2"]:SetText(_G[LootItemGUID.."Table"].itemLevel)
		RollNumberFrame:Show()
		RollNumberFrame:SetParent(nil)
	end
	
	if _G[LootItemGUID..";RollFrame"]:IsShown()==nil -- if Roll recount frame exists and is not shown, show it - possibly disable later?
		then  _G[LootItemGUID..";RollFrame"]:Show()
	end
		
		--dprint ("LBR DEBUG 573 - _G[LootItemGUID..Table].HighestRoll=",_G[LootItemGUID.."Table"].HighestRoll)
	
	if _G[LootItemGUID.."Table"].HighestRoll==nil then-- if this is the first roll announced for this GUID
		--dprint ("LBR DEBUG 534 - first roll for this item, right?")
		_G[LootItemGUID.."Table"].Rolls={}
		_G[LootItemGUID.."Table"].HighestRoll=roll
		_G[LootItemGUID.."Table"].HighestSender=sendername
		_G[LootItemGUID.."Table"].HighestRollType=rolltype
		_G[LootItemGUID.."Table"].HighestCurrentItemName=ItemName
		_G[LootItemGUID.."Table"].HighestCurrentItemLevel=ItemLevel
		_G[LootItemGUID.."Table"].HighestCurrentItemLink=itemLink
		_G[LootItemGUID.."Table"].GuildRankName=guildRankName
		_G[LootItemGUID..";RollFrameRoll2"]:SetText(roll)
		_G[LootItemGUID..";RollFrameName"]:SetText(sendername)
		_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
--		dprint ("LBR DEBUG 227: _G[LootItemGUID..'Table'].itemlink=",_G[LootItemGUID.."Table"].itemlink)
		_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		
	end
	
	if tonumber(roll)>=tonumber(_G[LootItemGUID.."Table"].HighestRoll) then -- by now there should always be a HighestRoll set, so no need to worry about it being nil
	
	--	dprint ("LBR DEBUG 552 - roll>highestroll=",roll,"/",_G[LootItemGUID.."Table"].HighestRoll)
		_G[LootItemGUID.."Table"].HighestRoll=roll
		_G[LootItemGUID.."Table"].HighestSender=sendername
		_G[LootItemGUID.."Table"].HighestRollType=rolltype
		_G[LootItemGUID.."Table"].HighestCurrentItemName=ItemName
		_G[LootItemGUID.."Table"].HighestCurrentItemLevel=ItemLevel
		_G[LootItemGUID.."Table"].HighestCurrentItemLink=itemLink
		_G[LootItemGUID.."Table"].GuildRankName=guildRankName
		_G[LootItemGUID..";RollFrameRoll2"]:SetText(roll)
		_G[LootItemGUID..";RollFrameName"]:SetText(sendername)
		-- need to update the highest roll part of the roll recount table 
	end
		
	tinsert (_G[LootItemGUID.."Table"].Rolls,roll)
	local howmanyrolled=strjoin("/",#(_G[LootItemGUID.."Table"].Rolls),GetNumGroupMembers())
	_G[LootItemGUID..";RollFrame"..";HowManyRolled"]:SetText(howmanyrolled)
	LBRFunctions.NameRollCount(sendername,rolltype)
	_G[LootItemGUID..";RollFrame;Disenchant"]:Hide()
	end
end

-- Sends LBRRoll
function LBRFunctions.Roll(rolltype,LootItemGUID) 
	local LBRName=LBRFunctions.GetMLName()
	local cItemName,cItemLevel,cItemLink=LBRFunctions.InspectItemSlot(_G[LootItemGUID.."Table"].itemEquipLoc)
	if cItemName=="-" then local cItemName,cItemLevel,cItemLink="0" return cItemName,cItemLevel,cItemLink end
	local message=strjoin(";",rolltype,LootItemGUID,cItemName,cItemLevel,cItemLink)
	SendAddonMessage("LBRRoll",message,"WHISPER",LBRName)
  end

  
  
--CALLED WHEN A BUTTON ON THE ITEM ROLL FRAME IS CLICKED
function RollButtonClick(ButtonName)
		
	local framename,LootItemGUID,rolltype=strsplit(";",ButtonName)
	--dprint("312-framename,LootItemGUID,rolltype=",framename,LootItemGUID,rolltype)
	
	--local eligible=LBRFunctions.CheckEligibles(LootItemGUID)
	--if eligible==nil then dprint ("LBR DEBUG 847 - seems like you´re not eligible to roll for this") end
		
	LBRFunctions.FreeSlots()
	
	LBRFunctions.Roll(rolltype,LootItemGUID)
		
	if _G[LootItemGUID..";RollFrame"]~=nil and _G[LootItemGUID..";RollFrame"]:IsShown()==nil then 
		_G[LootItemGUID..";RollFrame"]:Show()
	end
	
	if _G[LootItemGUID..";RollFrame"]==nil then
		local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[ButtonName]:GetParent(),"RollNumberFrame")
		RollNumberFrame:Show()
		_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		_G[LootItemGUID..";RollFrame;Itemlevel2"]:SetText(_G[LootItemGUID.."Table"].itemLevel)
		RollNumberFrame:Show()
		RollNumberFrame:SetParent(nil)
	end	

	
	_G[ButtonName]:GetParent():Hide()
	
end


--creates a table to store information about an item while it is being rolled for
function LBRFunctions.RollItemTable(LootItemGUID,lootIcon,lootName,index,itemLink,itemEquipLoc,Randomn,corpseName)
							_G[LootItemGUID.."Table"]={}
							_G[LootItemGUID.."Table"].GUID=LootItemGUID
							_G[LootItemGUID.."Table"].PlayersRolled={}
							_G[LootItemGUID.."Table"].lootIcon=lootIcon
							_G[LootItemGUID.."Table"].lootName=lootName
							_G[LootItemGUID.."Table"].index=index
							_G[LootItemGUID.."Table"].itemLink=itemLink
							_G[LootItemGUID.."Table"].itemLevel=itemLevel
							_G[LootItemGUID.."Table"].itemEquipLoc=itemEquipLoc
							_G[LootItemGUID.."Table"].Randomn=Randomn
							_G[LootItemGUID.."Table"].corpseName=LBRcorpseName
		
end

-- determines modifier for each roll type
function LBRFunctions.RollType(message)
	if message=="Major" then  modifier =LBRGuildRanks["Major"]
	elseif message=="Minor" then  modifier =LBRGuildRanks["Minor"]
	elseif message=="OffSpec" then  modifier =LBRGuildRanks["OffSpec"]
	elseif message=="BIS" then  modifier =LBRGuildRanks["BIS"]
	elseif message=="Pass" then  modifier =-10000
	--print (modifier)
	end		
return modifier
end

--creates a roll for an item with a given guid, that is not equal to any previous roll on the same item
function LBRFunctions.RollWithoutTies(LootItemGUID,rollmin,rollmax)
do
	if type(_G[LootItemGUID.."Table"])~="table" then _G[LootItemGUID.."Table"]={}
	else
	
		repeat
			local roll=math.random(rollmin,rollmax)
			return roll
		until tContains(_G[LootItemGUID.."Table"].Rolls,roll)==nil
			
		tinsert (_G[LootItemGUID.."Table"],roll)
		return roll
		end
		return roll
	end
end


function LBRFunctions.SendLongMessage(prefix,message,channel,target,functionCall)

	dprint ("LBR DEBUG 1365 - message has ",strlen(message)," characters, prefix/channel/target=",prefix,"/",channel,"/",target," functionCall=",functionCall)
	
	
	--CREATE A MESSAGE GUID AND INCLUDE WHICH FUNCTION TO PASS MESSAGE TO AFTER IT´S BEEN RECONSTRUCTED 
	
	local longMessageGUID=LBRFunctions.StringEval(message)
	dprint("longMessageGUID=",longMessageGUID)
	if functionCall==nil then functionCall=dprint end
	
	--CHECKING HOW LONG MESSAGE IS - IF IT NEEDS TO BE SPLIT, SPLIT IT!
	if strlen(message)>225 then 
		
		--MAKE A TABLE CONTAINING INDIVIDUAL MESSAGE ELEMENTS (MAKES SENSE)
		local oldmessageTable={strsplit(";",message)}
		
		--AND MAKE A NEW TABLE FOR THE NEW MESSAGE
		local messageSegment=nil
		local newmessageTable={}
		
		--AND MAKE SURE THERE ARE NO REMNANTS FROM BEFORE
		messageSegment=nil
		
		--FOR EACH SEGMENT OF THE INITIAL MESSAGE
				for i=1,#oldmessageTable do
					
					
					--IF THIS IS THE FIRST PART OF THE MESSAGE, ADD IT TO THE "messageSegment" AND GIVE IT THE PREFIX MSTA AND ITERATOR
					if messageSegment==nil and i==1 then 
						messageSegment=strjoin("-","Msta",longMessageGUID,oldmessageTable[i])
						--dprint ("LBR DEBUG 168 - 1st message part looks like this:", messageSegment)
					
					
					--IF THIS IS NOT THE FIRST PART OF THE MESSAGE, ADD IT TO "messageSegment" SEPARATED BY ;
					elseif messageSegment~=nil then 
						messageSegment=strjoin(";",messageSegment,oldmessageTable[i])
						--dprint ("LBR DEBUG 163 - message part ",i," looks like this:", messageSegment)
					
					
					--IF MESSAGEPART IS NIL BECAUSE WE ARE STARTING A NEW (NOT FIRST) LONGMESSAGE SEGMENT, PREFIX IT WITH MMID, ITERATOR AND ADD NEXT PART OF MESSAGE				
					elseif messageSegment==nil and i~=1 then 
						messageSegment=strjoin ("-","Mmid",longMessageGUID,oldmessageTable[i])
						--dprint ("LBR DEBUG 173 -  message part ",i," looks like this:", messageSegment)
					end
					
					
					--IF WE HAVE REACHED THE LAST PART OF THE MESSAGE, ADD TO THE END MEND AND ITERATOR TO "messageSegment" 
					if i==#oldmessageTable then
						messageSegment=string.gsub(messageSegment, "Mmid", functionCall, 1)
						--messageSegment=strjoin("-",messageSegment,"Mend")
						tinsert (newmessageTable,messageSegment)
						--dprint("LBR DEBUG 1393 - Last element of the LongAddonMessage was sent, containing ",strlen(messageSegment)," characters.")
						--dprint("messagepart=",messageSegment)
						messageSegment=nil
					end
					
					--IF WE ARE NOT AT THE END OF THE TABLE AND LONGMESSAGE SEGMENT IS LONGER THAN 220 CHARACTERS, SEND MESSAGE AND CLEAR "messageSegment"
					if i~=#oldmessageTable and strlen(messageSegment)>210 then	
						--SendAddonMessage(prefix,messageSegment,channel,target)
						tinsert (newmessageTable,messageSegment)
							
						--dprint("LBR DEBUG 1399 - sent LongAddonMessage contained ",i, " elements and ",strlen(messageSegment)," characters. This is not the last part of the message.")
						--dprint("messagepart=",messageSegment)
						messageSegment=nil
					end
				
				end
					
					--NOW THE TABLE IS FULL - SEND IT BY DELAYED CALLBACK AT A RATE OF 1 MESSAGE PER HALF A SECOND
					for i=1,#newmessageTable do
						C_Timer.After(i*0.5,function() dprint ("stringlength of sent message was ",strlen(newmessageTable[i])) end)
						C_Timer.After(i*0.5,function() SendAddonMessage(prefix,newmessageTable[i],channel,target) end)
					end
		
		
		--IF MESSAGE IS SHORTER THAN 255, SEND IT AT ONCE			
		elseif strlen(message)<=225 then 
			SendAddonMessage(prefix,strjoin("-","Msta",longMessageGUID,message,"Mend"),channel,target)
			dprint("LBR DEBUG 208 - sent LongAddonMessage contained 1 element and ",(strlen(message)+strlen(longMessageGUID)+10)," characters")
		end
end


--EVALUATES STRINGS (USED FOR SYNCING )
function LBRFunctions.StringEval(s)
	 local bit_band, bit_bxor, bit_rshift, str_byte, str_len = bit.band, bit.bxor, bit.rshift, string.byte, string.len
	 local consts = { 0x00000000, 0x77073096, 0xEE0E612C, 0x990951BA, 0x076DC419, 0x706AF48F, 0xE963A535, 0x9E6495A3, 0x0EDB8832, 0x79DCB8A4, 0xE0D5E91E, 0x97D2D988, 0x09B64C2B, 0x7EB17CBD, 0xE7B82D07, 0x90BF1D91, 0x1DB71064, 0x6AB020F2, 0xF3B97148, 0x84BE41DE, 0x1ADAD47D, 0x6DDDE4EB, 0xF4D4B551, 0x83D385C7, 0x136C9856, 0x646BA8C0, 0xFD62F97A, 0x8A65C9EC, 0x14015C4F, 0x63066CD9, 0xFA0F3D63, 0x8D080DF5, 0x3B6E20C8, 0x4C69105E, 0xD56041E4, 0xA2677172, 0x3C03E4D1, 0x4B04D447, 0xD20D85FD, 0xA50AB56B, 0x35B5A8FA, 0x42B2986C, 0xDBBBC9D6, 0xACBCF940, 0x32D86CE3, 0x45DF5C75, 0xDCD60DCF, 0xABD13D59, 0x26D930AC, 0x51DE003A, 0xC8D75180, 0xBFD06116, 0x21B4F4B5, 0x56B3C423, 0xCFBA9599, 0xB8BDA50F, 0x2802B89E, 0x5F058808, 0xC60CD9B2, 0xB10BE924, 0x2F6F7C87, 0x58684C11, 0xC1611DAB, 0xB6662D3D, 0x76DC4190, 0x01DB7106, 0x98D220BC, 0xEFD5102A, 0x71B18589, 0x06B6B51F, 0x9FBFE4A5, 0xE8B8D433, 0x7807C9A2, 0x0F00F934, 0x9609A88E, 0xE10E9818, 0x7F6A0DBB, 0x086D3D2D, 0x91646C97, 0xE6635C01, 0x6B6B51F4, 0x1C6C6162, 0x856530D8, 0xF262004E, 0x6C0695ED, 0x1B01A57B, 0x8208F4C1, 0xF50FC457, 0x65B0D9C6, 0x12B7E950, 0x8BBEB8EA, 0xFCB9887C, 0x62DD1DDF, 0x15DA2D49, 0x8CD37CF3, 0xFBD44C65, 0x4DB26158, 0x3AB551CE, 0xA3BC0074, 0xD4BB30E2, 0x4ADFA541, 0x3DD895D7, 0xA4D1C46D, 0xD3D6F4FB, 0x4369E96A, 0x346ED9FC, 0xAD678846, 0xDA60B8D0, 0x44042D73, 0x33031DE5, 0xAA0A4C5F, 0xDD0D7CC9, 0x5005713C, 0x270241AA, 0xBE0B1010, 0xC90C2086, 0x5768B525, 0x206F85B3, 0xB966D409, 0xCE61E49F, 0x5EDEF90E, 0x29D9C998, 0xB0D09822, 0xC7D7A8B4, 0x59B33D17, 0x2EB40D81, 0xB7BD5C3B, 0xC0BA6CAD, 0xEDB88320, 0x9ABFB3B6, 0x03B6E20C, 0x74B1D29A, 0xEAD54739, 0x9DD277AF, 0x04DB2615, 0x73DC1683, 0xE3630B12, 0x94643B84, 0x0D6D6A3E, 0x7A6A5AA8, 0xE40ECF0B, 0x9309FF9D, 0x0A00AE27, 0x7D079EB1, 0xF00F9344, 0x8708A3D2, 0x1E01F268, 0x6906C2FE, 0xF762575D, 0x806567CB, 0x196C3671, 0x6E6B06E7, 0xFED41B76, 0x89D32BE0, 0x10DA7A5A, 0x67DD4ACC, 0xF9B9DF6F, 0x8EBEEFF9, 0x17B7BE43, 0x60B08ED5, 0xD6D6A3E8, 0xA1D1937E, 0x38D8C2C4, 0x4FDFF252, 0xD1BB67F1, 0xA6BC5767, 0x3FB506DD, 0x48B2364B, 0xD80D2BDA, 0xAF0A1B4C, 0x36034AF6, 0x41047A60, 0xDF60EFC3, 0xA867DF55, 0x316E8EEF, 0x4669BE79, 0xCB61B38C, 0xBC66831A, 0x256FD2A0, 0x5268E236, 0xCC0C7795, 0xBB0B4703, 0x220216B9, 0x5505262F, 0xC5BA3BBE, 0xB2BD0B28, 0x2BB45A92, 0x5CB36A04, 0xC2D7FFA7, 0xB5D0CF31, 0x2CD99E8B, 0x5BDEAE1D, 0x9B64C2B0, 0xEC63F226, 0x756AA39C, 0x026D930A, 0x9C0906A9, 0xEB0E363F, 0x72076785, 0x05005713, 0x95BF4A82, 0xE2B87A14, 0x7BB12BAE, 0x0CB61B38, 0x92D28E9B, 0xE5D5BE0D, 0x7CDCEFB7, 0x0BDBDF21, 0x86D3D2D4, 0xF1D4E242, 0x68DDB3F8, 0x1FDA836E, 0x81BE16CD, 0xF6B9265B, 0x6FB077E1, 0x18B74777, 0x88085AE6, 0xFF0F6A70, 0x66063BCA, 0x11010B5C, 0x8F659EFF, 0xF862AE69, 0x616BFFD3, 0x166CCF45, 0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2, 0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB, 0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0, 0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9, 0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6, 0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF, 0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94, 0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D }
	 
	  local crc, l, i = 0xFFFFFFFF, str_len(s)
	  for i = 1, l, 1 do
	   crc = bit_bxor(bit_rshift(crc, 8), consts[bit_band(bit_bxor(crc, str_byte(s, i)), 0xFF) + 1])
	  end
  return bit_bxor(crc, -1)
end

--string stripper
function LBRFunctions.Strip(cname) 
  return string.gsub(cname, "%W", "")
end

-- slash command register
SLASH_LBR1, SLASH_LBR2 = '/lbr', '/LBR';
function SlashCmdList.LBR(msg, editbox)
	local arg0,arg1,arg2=string.lower(strsplit(" ",msg))
		if arg0=="debug" then 
			if LBRDebug==true then LBRDebug=nil print ("turning debug off") 
			elseif LBRDebug==nil then LBRDebug=true  print ("turning debug on")
		end
		
		elseif arg0=="" then
			LBRFunctions.UIWindow()
		
		elseif arg0=="options" then
			LBRFunctions.OptionsPanel()
					
		elseif arg0=="history" then
			LBRFunctions.HistoryPanel()
			
		elseif arg0=="counters" then
			LBRFunctions.PlayerCounters()
			
		elseif arg0=="syn" then
			LBRFunctions.Zynchronize()
			
		elseif arg0=="test" then
			LBRFunctions.test()
		
		elseif arg0=="help" then
		print(" ")
		print("Looting by ranks by Goneril@Frostmane EU")
		print(" ")
		print("|cFF00FF00 /lbr options |r for setting roll ranges for guild ranks, loot threshold and ilvl diff coefficient")
		print("|cFF00FF00 /lbr history |r for viewing history of awarded items")
		print("|cFF00FF00 /lbr debug - |r(toggles debug messages on/off (this addon is still in development, keeping this here to help with possible issues)")
		print(" ")
		
		else
		print(" ")
		print("Looting by ranks by Goneril@Frostmane EU")		
		print(" ")
		print("|cFF00FF00 /lbr options |r for setting roll ranges for  guild ranks, loot threshold and ilvl diff coefficient")
		print("|cFF00FF00 /lbr history |r for viewing history of awarded items")
		print("|cFF00FF00 /lbr debug - |r(toggles debug messages on/off (this addon is still in development, keeping this here to help with possible issues)")
		print(" ")

	end
end

-- inserts one table into another
function LBRFunctions.TableCopy(sourcetable, targettable)
	for k,v in pairs(sourcetable) do
	 targettable[k] = v
	end
return targettable
end


--FOR ENUMERATING TABLES FOR SYNCING PURPOSES
function LBRFunctions.TableEval(table, numberofkeys)
if LBRVar==nil then LBRVar={} end

LBRVar.TempString=""
	for k,v in ipairs(table) do
		--dprint("1525-v=",v)
		LBRVar.TempString=strjoin("",LBRVar.TempString,v)
	end
		
	--dprint("1527-StringEval(LBRVar.TempString),  of tempstring is",LBRFunctions.StringEval(LBRVar.TempString))
	--dprint("1527-strlen of tempstring is",strlen(LBRVar.TempString))
	return (LBRFunctions.StringEval(LBRVar.TempString))
end

function LBRFunctions.TablePrint(table)
	print("TablePrint printing table ",table)
	for i=0,#table do
		print("table [",i"] =", table[i])
	end
end


--Adds up values across multiple tables
function LBRFunctions.TableSum(table)
      local sum = 0
      for k,v in ipairs(table) do
        sum = sum + v
      end
      return sum
end


--removes a value from a table
function LBRFunctions.tRemoveByVal(table, value)
   for k,v in pairs(table) do
     if(v==value) then
       tremove(table, k);
     end
   end
 end

--provides the main addon UI from which other tables are launched
function LBRFunctions.UIWindow()
local mainUIPanel = CreateFrame("frame","mainUIPanelFrame")

		-- elseif arg0=="options" then
			-- LBRFunctions.OptionsPanel()
					
		-- elseif arg0=="history" then
			-- LBRFunctions.HistoryPanel()
			
		-- elseif arg0=="counters" then
			-- LBRFunctions.PlayerCounters()
			
		-- elseif arg0=="syn" then
			-- LBRFunctions.Zynchronize()
			
		-- elseif arg0=="test" then
			-- LBRFunctions.test()
			
		--	LBRFunctions.PlayerCounters()
		

	mainUIPanel:SetBackdrop({
		  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
		  edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		  tile=1, tileSize=32, edgeSize=32, 
		  insets={left=11, right=12, top=12, bottom=11}
	})
	mainUIPanel:SetWidth(240)
	mainUIPanel:SetHeight(100)
	mainUIPanel:SetPoint("CENTER",UIParent)
	mainUIPanel:EnableMouse(true)
	mainUIPanel:SetMovable(true)
	mainUIPanel:RegisterForDrag("LeftButton")
	mainUIPanel:SetScript("OnDragStart", function(self) self:StartMoving() end)
	mainUIPanel:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	mainUIPanel:SetFrameStrata("FULLSCREEN_DIALOG")

	local optionsbutton = CreateFrame("button","mainUIPanelButton", mainUIPanel, "UIPanelButtonTemplate")
	optionsbutton:SetHeight(14)
	optionsbutton:SetWidth(60)
	optionsbutton:SetPoint("BOTTOM", mainUIPanel, "BOTTOM", -72, 10)
	optionsbutton:SetText("Options")
	optionsbutton:SetScript("OnClick", 	function(self) 
											PlaySound("igMainMenuOption") 
											self:GetParent():Hide() 
											LBRFunctions.OptionsPanel()
										end)

	local historybutton = CreateFrame("button","mainUIPanelButton", mainUIPanel, "UIPanelButtonTemplate")
	historybutton:SetHeight(14)
	historybutton:SetWidth(60)
	historybutton:SetPoint("BOTTOM", mainUIPanel, "BOTTOM", -8, 10)
	historybutton:SetText("History")
	historybutton:SetScript("OnClick", 	function(self)
											PlaySound("igMainMenuOption") 
											self:GetParent():Hide() 
											LBRFunctions.HistoryPanel()
										end)
										
	local counterbutton = CreateFrame("button","mainUIPanelButton", mainUIPanel, "UIPanelButtonTemplate")
	counterbutton:SetHeight(14)
	counterbutton:SetWidth(60)
	counterbutton:SetPoint("BOTTOM", mainUIPanel, "BOTTOM", 56, 10)
	counterbutton:SetText("Counters")
	counterbutton:SetScript("OnClick", 	function(self)
											PlaySound("igMainMenuOption") 
											self:GetParent():Hide() 
											LBRFunctions.PlayerCounters()
										end)
	
	local mainUICloseButton = CreateFrame("button","mainUIPanelButton", mainUIPanel, "UIPanelCloseButton")
	mainUICloseButton:SetSize(20,20)
	mainUICloseButton:SetPoint("TOPRIGHT",-
	
	3,-5)
	mainUICloseButton:SetScript("OnClick", 	function(self)
											PlaySound("igMainMenuOption") 
											self:GetParent():Hide() 
										end)
										
	local helpbutton = CreateFrame("button","mainUIPanelButton", mainUIPanel, "UIPanelButtonTemplate")
	helpbutton:SetSize(18,14)
	helpbutton:SetPoint("BOTTOM", mainUIPanel, "BOTTOM", 96, 10)
	helpbutton:SetText("?")
	helpbutton:SetScript("OnClick", 	function(self)
											 PlaySound("igMainMenuOption") 
											 self:GetParent():Hide()
											 print(" ")
		print("Looting by ranks by Goneril@Frostmane EU")
		print(" ")
		print("Help can go here and/or be put into a separate window (harder) and/or I can try to add tooltips, but goal is to have it be pretty straightforward.")
		print("|cFF00FF00 /lbr debug - |r(toggles debug messages on/off (this addon is still in development, keeping this here to help with possible issues)")
		print(" ")
	end)
	
	local confirmationFS = mainUIPanel:CreateFontString("confirmationFS","OVERLAY", "GameFontNormal")
	enabled = confirmationFS:CanWordWrap() 
	confirmationFS:SetPoint("TOPLEFT",20,-20)
	confirmationFS:SetSize(200, 40)
	confirmationFS:SetFont("Fonts\\FRIZQT__.TTF", 15)
	confirmationFS:SetText("Looting by ranks")
	confirmationFS:Show()
	
end

 
 
 
 
 
--Event handler
function LBRFrame.OnEvent(self,event,arg1,arg2,arg3,arg4) -- reacts to events firing
 	
	--reacting to being loaded
	if event == "ADDON_LOADED" and arg1 == "LootByRanks" then  
	
	LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("LootByRanks", {
	type = "launcher",
	text = "LBR",
	icon = "Interface\\ICONS\\Racial_Dwarf_FindTreasure",
	OnClick = function(clickedframe, button)
		dprint("LBR 2347 - LDB icon clicked")
		LBRFunctions.UIWindow()
	end,
})
				
	elseif event == "PARTY_LOOT_METHOD_CHANGED" then 
		local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
		
		if lootmethod =="master" then
			--local LBRSettingsChecksum=(LBRFunctions.CheckSum(LBRSettings))
			--LBRSettingsRequestString=LBRFunctions.GetMLName()
			LBRFunctions.OptionsSyncRequest()
			dprint("LBR 2328- requesting sync")
			
		end
	elseif event == "OPEN_MASTER_LOOT_LIST" then 
		LBRFunctions.OpenLootWindow()
		
	elseif event == "LOOT_OPENED" then
		--LBRFunctions.OpenLootWindow() --only to be used when debugging, if left un, will trigger loot window without master looter!
	
	elseif event == "CHAT_MSG_LOOT" then
			 --dprint(" 129 - arg1=",arg1)

	elseif event == "CHAT_MSG_ADDON" then 
		
		if arg1=="LBRItem1" then 
			--dprint("Received CHAT_MSG_ADDON - arg1=",arg1," arg2=",arg2," arg3=", arg3, "arg4=",arg4)
			LBRFunctions.ReceiveLBRItem1(arg2) 
		end
		
		if arg1=="LBRRoll" then 
			LBRFunctions.ProcessRoll(arg1,arg2,arg3,arg4) 
		end
		
		if arg1=="LBRRollAnnounce" then 
			LBRFunctions.RollAnnounce(arg2) 
		end
		
		if arg1 == "LBRReply" then
			LBRFunctions.ReceiveReply(arg2)
		end
		
		if arg1 == "LBRAwarded" then
			dprint("1622-registered LBRAwarded")
			LBRFunctions.PrintAwarded(arg2)
		end
		
		if arg1 == "LongM" then
			--dprint("receiving")
			LBRFunctions.ReceiveLongMessage(arg2)
		end
		
		
		if arg1 == "LBROptions1" then
					--print("LBROptions1 received, starting LBRFunctions.OptionsSyncSend(arg2) with value ", LBRFunctions.OptionsSyncSend(arg4))
					LBRFunctions.OptionsSyncSend(arg4)
		end
				
		if arg1 == "LBROptions2" then
					--dprint("receiving")
					--print("LBR1754 DEBUG- received message ",arg2," from ",arg4)
					LBRFunctions.OptionsSyncReceive(arg2)
		end
		
	end
end

function LBRFunctions.SendThrottledMessage()
	-- if LBRTimer==nil then LBRTimer=0 end
	-- if LBRTimer<=10 then
		-- print("timer=",LBRTimer)
		-- LBRTimer=LBRTimer+1
		-- C_Timer.After(1,function() LBRFunctions.Zynchronize() end)
	-- end
end



 function LBRFunctions.test()
			
		
	--local testcheckum=LBRFunctions.CheckSum(LBRSettings)
	--print("LBR settings checksum=",testcheckum)
	--LBRFunctions.OptionsmainUIPanel()
 
 end

-- --FOR TESTING TableEval
 -- function LBRFunctions.test()
	-- local tableChecksum=LBRFunctions.TableEval(LBRHistoryIndex,5)
	-- dprint("1618-tableChecksum=",tableChecksum)
 -- end

function LBRFunctions.TestIterateTable()
	if numOnlineMembers==nil then 
		numTotalMembers, numOnlineMaxLevelMembers, numOnlineMembers = GetNumGuildMembers() 
	end
	
	if LBRCounter==nil then LBRCounter=1 end
		
	if LBRCounter<=numOnlineMembers then
		C_Timer.After(1,function() LBRFunctions.test()
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile = GetGuildRosterInfo(LBRCounter)
		local name,realm=strsplit("-",name)
		dprint ("now looking at ",name)
		LBRCounter=LBRCounter+1
	end)
	end
end










--This points back to the event handler (must be below it in order to run)
LBRFrame:SetScript("OnEvent", LBRFrame.OnEvent)